Package: LearnBayes
Type: Package
Title: Functions for Learning Bayesian Inference
Version: 2.15.2
Date: 2026-01-29
Authors@R: person("Jim", "Albert", email = "albert@bgsu.edu",
  role = c("aut", "cre"))
Maintainer: Jim Albert <albert@bgsu.edu>
LazyData: yes
Description: A collection of functions helpful in learning the basic tenets of Bayesian statistical inference.  It contains functions for summarizing basic one and two parameter posterior distributions and predictive distributions.  It contains MCMC algorithms for summarizing posterior distributions defined by the user.  It also contains functions for regression models, hierarchical models, Bayesian tests, and illustrations of Gibbs sampling.
License: GPL (>= 2)
Packaged: 2026-01-30 18:17:01 UTC; jimalbert
NeedsCompilation: no
Repository: CRAN
Date/Publication: 2026-01-31 07:40:50 UTC
RoxygenNote: 7.3.3
Imports: coda, lattice, survival
Author: Jim Albert [aut, cre]
Built: R 4.6.0; ; 2026-04-27 14:52:07 UTC; unix

exportPattern("^[[:alpha:]]+")
importFrom("grDevices", "gray")
importFrom("graphics", "barplot", "contour", "image", "legend",
             "lines", "plot", "points", "text")
importFrom("stats", "approx", "binomial", "dbeta", "dbinom", "dgamma",
             "dnorm", "dpois", "dt", "glm", "hat", "lm", "model.matrix",
             "optim", "pbeta", "pnorm", "qnorm", "quantile", "rchisq",
             "rgamma", "rnorm", "runif", "sd", "vcov")
importFrom("survival", "survreg")
importFrom("coda", "autocorr.plot", "acfplot")
importFrom("lattice", "xyplot", "densityplot")
S3method(print, bayes)
S3method(plot, bayes)
S3method(plot, bayes2)
S3method(summary, bayes)

#########################################################
# Section 7.7 Simulating from the Posterior
#########################################################

 library(LearnBayes)
 data(hearttransplants)
 attach(hearttransplants)

 datapar = list(data = hearttransplants, z0 = 0.53)
 start=c(2, -7)
 fit = laplace(poissgamexch, start, datapar)
 fit

 par(mfrow = c(1, 1))
 mycontour(poissgamexch, c(0, 8, -7.3, -6.6), datapar,
   xlab="log alpha",ylab="log mu")

S=readline(prompt="Type  <Return>   to continue : ")

 start = c(4, -7)
 fitgibbs = gibbs(poissgamexch, start, 1000, c(1,.15), datapar)
 fitgibbs$accept

 windows()
 mycontour(poissgamexch, c(0, 8, -7.3, -6.6), datapar,
     xlab="log alpha",ylab="log mu")
 points(fitgibbs$par[, 1], fitgibbs$par[, 2])

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 plot(density(fitgibbs$par[, 1], bw = 0.2))

 alpha = exp(fitgibbs$par[, 1])
 mu = exp(fitgibbs$par[, 2])
 lam1 = rgamma(1000, y[1] + alpha, e[1] + alpha/mu)

 alpha = exp(fitgibbs$par[, 1])
 mu = exp(fitgibbs$par[, 2])

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 plot(log(e), y/e, pch = as.character(y))
 for (i in 1:94) {
     lami = rgamma(1000, y[i] + alpha, e[i] + alpha/mu)
     probint = quantile(lami, c(0.05, 0.95))
     lines(log(e[i]) * c(1, 1), probint)
 }

###################################################
# Section 10.4 Estimating a Table of Means
###################################################

library(LearnBayes)

 data(iowagpa)
 rlabels = c("91-99", "81-90", "71-80", "61-70", "51-60", "41-50", 
     "31-40", "21-30")
 clabels = c("16-18", "19-21", "22-24", "25-27", "28-30")
 gpa = matrix(iowagpa[, 1], nrow = 8, ncol = 5, byrow = T)
 dimnames(gpa) = list(HSR = rlabels, ACTC = clabels)
 gpa

 samplesizes = matrix(iowagpa[, 2], nrow = 8, ncol = 5, byrow = T)
 dimnames(samplesizes) = list(HSR = rlabels, ACTC = clabels)
 samplesizes

 act = seq(17, 29, by = 3)
 matplot(act, t(gpa), type = "l", lwd = 3, 
  xlim = c(17, 34), col=1:8, lty=1:8)
 legend(30, 3, lty = 1:8, lwd = 3, legend = c("HSR=9", "HSR=8", 
     "HSR=7", "HSR=6", "HSR=5", "HSR=4", "HSR=3", "HSR=2"), col=1:8)

S=readline(prompt="Type  <Return>   to continue : ")

 MU = ordergibbs(iowagpa, 5000)

 postmeans = apply(MU, 2, mean)
 postmeans = matrix(postmeans, nrow = 8, ncol = 5)
 postmeans=postmeans[seq(8,1,-1),]
 dimnames(postmeans)=list(HSR=rlabels,ACTC=clabels)
 round(postmeans,2)

windows()
matplot(act, t(postmeans), type = "l", lty=1:8, lwd = 3, col = 1, xlim = c(17, 34))
 legend(30, 3, lty = 1:8, lwd = 2, legend = c("HSR=9", "HSR=8", 
     "HSR=7", "HSR=6", "HSR=5", "HSR=4", "HSR=3", "HSR=2"))

 postsds = apply(MU, 2, sd)
 postsds = matrix(postsds, nrow = 8, ncol = 5)
 postsds=postsds[seq(8,1,-1),]
 dimnames(postsds)=list(HSR=rlabels,ACTC=clabels)
 round(postsds,3)

 s=.65
 se=s/sqrt(samplesizes)
 round(postsds/se,2)

S=readline(prompt="Type  <Return>   to continue : ")

 FIT=hiergibbs(iowagpa,5000)

windows()
 par(mfrow=c(2,1))
 plot(density(FIT$beta[,2]),xlab=expression(beta[2]),
  main="HIGH SCHOOL RANK")
 plot(density(FIT$beta[,3]),xlab=expression(beta[3]),
  main="ACT SCORE")
 quantile(FIT$beta[,2],c(.025,.25,.5,.75,.975))

 quantile(FIT$beta[,3],c(.025,.25,.5,.75,.975))

 quantile(FIT$var,c(.025,.25,.5,.75,.975))

 posterior.means = apply(FIT$mu, 2, mean)
 posterior.means = matrix(posterior.means, nrow = 8, ncol = 5, 
  byrow = T)

S=readline(prompt="Type  <Return>   to continue : ")

windows()
 par(mfrow=c(1,1))
 matplot(act, t(posterior.means), type = "l", lwd = 3, lty=1:8, col=1,
   xlim = c(17, 34))
 legend(30, 3, lty = 1:8, lwd = 2, legend = c("HSR=9", "HSR=8", 
     "HSR=7", "HSR=6", "HSR=5", "HSR=4", "HSR=3", "HSR=2"))

 p=1-pnorm((2.5-FIT$mu)/.65)
 prob.success=apply(p,2,mean)

 prob.success=matrix(prob.success,nrow=8,ncol=5,byrow=T)
 dimnames(prob.success)=list(HSR=rlabels,ACTC=clabels)
 round(prob.success,3)

#####################################
# Section 2.5 Using a Histogram Prior
#####################################

 library(LearnBayes)

 midpt = seq(0.05, 0.95, by = 0.1)
 prior = c(1, 5.2, 8, 7.2, 4.6, 2.1, 0.7, 0.1, 0, 0)
 prior = prior/sum(prior)
 
 curve(histprior(x,midpt,prior), from=0, to=1,
   ylab="Prior density",ylim=c(0,.3))

 s = 11
 f = 16

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 curve(histprior(x,midpt,prior) * dbeta(x,s+1,f+1), 
   from=0, to=1, ylab="Posterior density")

S=readline(prompt="Type  <Return>   to continue : ")

 p = seq(0, 1, length=500)
 post = histprior(p, midpt, prior) *
        dbeta(p, s+1, f+1)
 post = post/sum(post)
 ps = sample(p, replace = TRUE, prob = post)

 windows()
 hist(ps, xlab="p", main="")

##################################################
# Section 6.8 Example of Output Analysis
##################################################
 library(LearnBayes)

 d=list(int.lo=c(-Inf,seq(66,74,by=2)),
        int.hi=c(seq(66,74,by=2), Inf),
        f=c(14,30,49,70,33,15))

 library(coda)
 library(lattice)

 start=c(70,1)
 fit=laplace(groupeddatapost,start,d)

 start=c(65,1)
 proposal=list(var=fit$var,scale=0.2)
 bayesfit=rwmetrop(groupeddatapost,proposal,start,10000,d)

 dimnames(bayesfit$par)[[2]]=c("mu","log sigma")
 xyplot(mcmc(bayesfit$par[-c(1:2000),]),col="black")

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 par(mfrow=c(2,1))
 autocorr.plot(mcmc(bayesfit$par[-c(1:2000),]),auto.layout=FALSE)
 summary(mcmc(bayesfit$par[-c(1:2000),]))
 batchSE(mcmc(bayesfit$par[-c(1:2000),]), batchSize=50)

S=readline(prompt="Type  <Return>   to continue : ")

 start=c(70,1)
 proposal=list(var=fit$var,scale=2.0)
 bayesfit=rwmetrop(groupeddatapost,proposal,start,10000,d)

 dimnames(bayesfit$par)[[2]]=c("mu","log sigma")
 sim.parameters=mcmc(bayesfit$par[-c(1:2000),])
 windows()
 xyplot(mcmc(bayesfit$par[-c(1:2000),]),col="black")

s=readline(prompt="Type  <Return>   to continue : ")

 windows()
 par(mfrow=c(2,1))
 autocorr.plot(sim.parameters,auto.layout=FALSE)
 summary(sim.parameters)
 batchSE(sim.parameters, batchSize=50)

# Section 1.2 R commands

# Section 1.2.2

library(LearnBayes)
data(studentdata)
studentdata[1,]
attach(studentdata)

# Section 1.2.3

table(Drink)
barplot(table(Drink),xlab="Drink",ylab="Count")

S=readline(prompt="Type  <Return>   to continue : ")

windows()
hours.of.sleep = WakeUp - ToSleep
summary(hours.of.sleep)
hist(hours.of.sleep,main="")

S=readline(prompt="Type  <Return>   to continue : ")

# Section 1.2.4

windows()

boxplot(hours.of.sleep~Gender,
  ylab="Hours of Sleep")

female.Haircut=Haircut[Gender=="female"]
male.Haircut=Haircut[Gender=="male"]
summary(female.Haircut)
summary(male.Haircut)

S=readline(prompt="Type  <Return>   to continue : ")

# Section 1.2.5

windows()

plot(jitter(ToSleep),jitter(hours.of.sleep))

fit=lm(hours.of.sleep~ToSleep)
fit
abline(fit)

#################################################
# Section 8.6 Models for Soccer Goals
#################################################

library(LearnBayes)

 data(soccergoals)
 attach(soccergoals)
 datapar=list(data=goals,par=c(4.57,1.43))
 fit1=laplace(logpoissgamma,.5,datapar)
 datapar=list(data=goals,par=c(1,.5))
 fit2=laplace(logpoissnormal,.5,datapar)
 datapar=list(data=goals,par=c(2,.5))
 fit3=laplace(logpoissnormal,.5,datapar)
 datapar=list(data=goals,par=c(1,2))
 fit4=laplace(logpoissnormal,.5,datapar)

 postmode=c(fit1$mode,fit2$mode,fit3$mode,fit4$mode)
 postsd=sqrt(c(fit1$var,fit2$var,fit3$var,fit4$var))
 logmarg=c(fit1$int,fit2$int,fit3$int,fit4$int)
 cbind(postmode,postsd,logmarg)

#################################################
# Section 7.9  Bayesian Sensitivity Analysis
#################################################

 library(LearnBayes)
 data(hearttransplants)
 attach(hearttransplants)

 datapar = list(data = hearttransplants, z0 = 0.53)

 start = c(4, -7)
 fitgibbs = gibbs(poissgamexch, start, 1000, c(1,.15), datapar)


sir.old.new=function(theta, prior, prior.new)
{
log.g=log(prior(theta))
log.g.new=log(prior.new(theta))
wt=exp(log.g.new-log.g-max(log.g.new-log.g))
probs=wt/sum(wt)
n=length(probs)
indices=sample(1:n,size=n,prob=probs,replace=TRUE)
theta[indices]
}

prior=function(theta)
0.53*exp(theta)/(exp(theta)+0.53)^2
prior.new=function(theta)
5*exp(theta)/(exp(theta)+5)^2

log.alpha=fitgibbs$par[, 1]
log.alpha.new=sir.old.new(log.alpha, prior, prior.new)

############ drawing figure

library(lattice)
draw.graph=function()
{
LOG.ALPHA=data.frame("prior",log.alpha)
names(LOG.ALPHA)=c("Prior","log.alpha")
LOG.ALPHA.NEW=data.frame("new.prior",log.alpha.new)
names(LOG.ALPHA.NEW)=c("Prior","log.alpha")
D=densityplot(~log.alpha,group=Prior,data=rbind(LOG.ALPHA,LOG.ALPHA.NEW),
   plot.points=FALSE,main="Original Prior and Posterior (solid), 
   New Prior and Posterior (dashed)",
    lwd=4,adjust=2,lty=c(1,2),xlab="log alpha",xlim=c(-3,5),col="black")
update(D, panel=function(...){
    panel.curve(prior(x),lty=1,lwd=2,col="black")
    panel.curve(prior.new(x),lty=2, lwd=2,col="black")
    panel.densityplot(...)
})}

draw.graph()

##########################################################
# Section 3.3 Estimating a Heart Transplant Mortality Rate
##########################################################

 alpha=16;beta=15174
 yobs=1; ex=66
 y=0:10
 lam=alpha/beta
 py=dpois(y, lam*ex)*dgamma(lam, shape = alpha,
   rate = beta)/dgamma(lam, shape= alpha + y,
   rate = beta + ex)
 cbind(y, round(py, 3))

 lambdaA = rgamma(1000, shape = alpha + yobs, rate = beta + ex)

 ex = 1767; yobs=4
 y = 0:10
 py = dpois(y, lam * ex) * dgamma(lam, shape = alpha, 
     rate = beta)/dgamma(lam, shape = alpha + y,
     rate = beta + ex)
 cbind(y, round(py, 3))

 lambdaB = rgamma(1000, shape = alpha + yobs, rate = beta + ex)

 par(mfrow = c(2, 1))
 plot(density(lambdaA), main="HOSPITAL A", xlab="lambdaA", lwd=3)
 curve(dgamma(x, shape = alpha, rate = beta), add=TRUE)
 legend("topright",legend=c("prior","posterior"),lwd=c(1,3))
 plot(density(lambdaB), main="HOSPITAL B", xlab="lambdaB", lwd=3)
 curve(dgamma(x, shape = alpha, rate = beta), add=TRUE)
 legend("topright",legend=c("prior","posterior"),lwd=c(1,3))

######################################################
# Section 5.6  The Example
######################################################

library(LearnBayes)

data(cancermortality)

 fit=laplace(betabinexch,c(-7,6),cancermortality)
 fit

npar=list(m=fit$mode,v=fit$var)
mycontour(lbinorm,c(-8,-4.5,3,16.5),npar,
  xlab="logit eta", ylab="log K")

 se=sqrt(diag(fit$var))
 fit$mode-1.645*se
 fit$mode+1.645*se

########################################################
# Section 7.5 Modeling a Prior Belief of Exchangeability
########################################################

library(LearnBayes)

pgexchprior=function(lambda,pars)
{
alpha=pars[1]; a=pars[2]; b=pars[3]
(alpha-1)*log(prod(lambda))-(2*alpha+a)*log(alpha*sum(lambda)+b)
}

alpha=c(5,20,80,400); par(mfrow=c(2,2))
for (j in 1:4)
    mycontour(pgexchprior,c(.001,5,.001,5),c(alpha[j],10,10),
      main=paste("ALPHA = ",alpha[j]),xlab="LAMBDA 1",ylab="LAMBDA 2")

##############################################
# Section 5.10 Sampling Importance Resampling
##############################################

library(LearnBayes)
data(cancermortality)
fit=laplace(betabinexch,c(-7,6),cancermortality)

tpar=list(m=fit$mode,var=2*fit$var,df=4)

theta.s=sir(betabinexch,tpar,10000,cancermortality)

 S=bayes.influence(theta.s,cancermortality)

 plot(c(0,0,0),S$summary,type="b",lwd=3,xlim=c(-1,21),
  ylim=c(5,11), xlab="Observation removed",ylab="log K")
 for (i in 1:20)
  lines(c(i,i,i),S$summary.obs[i,],type="b")

####################################
# Section 2.3 Using a Discrete Prior
####################################

 library(LearnBayes)

 p = seq(0.05, 0.95, by = 0.1)
 prior = c(1, 5.2, 8, 7.2, 4.6, 2.1, 0.7, 0.1, 0, 0)
 prior = prior/sum(prior)
 plot(p, prior, type = "h", ylab="Prior Probability")

S=readline(prompt="Type  <Return>   to continue : ")

 data = c(11, 16)
 post = pdisc(p, prior, data)
 round(cbind(p, prior, post),2)

 PRIOR=data.frame("prior",p,prior)
 POST=data.frame("posterior",p,post)
 names(PRIOR)=c("Type","P","Probability")
 names(POST)=c("Type","P","Probability")
 data=rbind(PRIOR,POST)

 windows()
 lattice::xyplot(Probability~P|Type,data=data,layout=c(1,2),type="h",lwd=3,col="black")

################################
# Section 2.4 Using a Beta Prior
#############################

library(LearnBayes)

quantile2=list(p=.9,x=.5)
quantile1=list(p=.5,x=.3)
ab=beta.select(quantile1,quantile2)

 a = ab[1]
 b = ab[2]
 s = 11
 f = 16
 curve(dbeta(x,a+s,b+f), from=0, to=1, 
       xlab="p",ylab="Density",lty=1,lwd=4)
 curve(dbeta(x,s+1,f+1),add=TRUE,lty=2,lwd=4)
 curve(dbeta(x,a,b),add=TRUE,lty=3,lwd=4)
 legend(.7,4,c("Prior","Likelihood","Posterior"),
     lty=c(3,2,1),lwd=c(3,3,3))

 1 - pbeta(0.5, a + s, b + f)

 qbeta(c(0.05, 0.95), a + s, b + f)

 ps = rbeta(1000, a + s, b + f)

 windows()
 hist(ps,xlab="p")

 sum(ps >= 0.5)/1000

 quantile(ps, c(0.05, 0.95))

########################
# Section 2.6 Prediction
########################

 library(LearnBayes)

 p=seq(0.05, 0.95, by=.1)
 prior = c(1, 5.2, 8, 7.2, 4.6, 2.1, 0.7, 0.1, 0, 0)
 prior=prior/sum(prior)
 m=20; ys=0:20
 pred=pdiscp(p, prior, m, ys)
 cbind(0:20,pred)

 ab=c(3.26, 7.19)
 m=20; ys=0:20
 pred=pbetap(ab, m, ys)

 p=rbeta(1000,3.26, 7.19)

 y = rbinom(1000, 20, p)

 table(y)

 freq=table(y)
 ys=as.integer(names(freq))
 predprob=freq/sum(freq)
 plot(ys,predprob,type="h",xlab="y",
   ylab="Predictive Probability")

 dist=cbind(ys,predprob)

 covprob=.9
 discint(dist,covprob)

###############################
# Section 10.2 Robust Modeling
###############################

library(LearnBayes)

 data(darwin)
 attach(darwin)
 fit=robustt(difference,4,10000)

 plot(density(fit$mu),xlab="mu")

 mean.lambda=apply(fit$lam,2,mean)
 lam5=apply(fit$lam,2,quantile,.05)
 lam95=apply(fit$lam,2,quantile,.95)

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 plot(difference,mean.lambda,lwd=2,ylim=c(0,3),ylab="Lambda")
 for (i in 1:length(difference))
   lines(c(1,1)*difference[i],c(lam5[i],lam95[i]))
 points(difference,0*difference-.05,pch=19,cex=2)

#################################################
# Section 7.10 Posterior Predictive Model Checking
#################################################

library(LearnBayes)
 data(hearttransplants)
 attach(hearttransplants)

 datapar = list(data = hearttransplants, z0 = 0.53)

 start = c(4, -7)
 fitgibbs = gibbs(poissgamexch, start, 1000, c(1,.15), datapar)

 lam94=rgamma(1000,y[94]+alpha,e[94]+alpha/mu)

 ys94=rpois(1000,e[94]*lam94)

 hist(ys94,breaks=seq(-0.5,max(ys94)+0.5))
 lines(y[94]*c(1,1),c(0,100),lwd=3)

S=readline(prompt="Type  <Return>   to continue : ")

prob.out=function(i)
{
   lami=rgamma(1000,y[i]+alpha,e[i]+alpha/mu)
   ysi=rpois(1000,e[i]*lami)
   pleft=sum(ysi<=y[i])/1000
   pright=sum(ysi>=y[i])/1000
   min(pleft,pright)
 }
pout.exchange=sapply(1:94,prob.out)

 windows()
 plot(pout,pout.exchange,xlab="P(extreme), equal means",
 ylab="P(extreme), exchangeable")
 abline(0,1)

##############################################
# Section 9.4 Survival Modeling
##############################################

 library(LearnBayes)

 data(chemotherapy)
 attach(chemotherapy)
 library(survival)
 survreg(Surv(time,status)~factor(treat)+age,dist="weibull")

 start=c(-.5,9,.5,-.05)
 d=cbind(time,status,treat-1,age)
 fit=laplace(weibullregpost,start,d)
 fit

 proposal=list(var=fit$var,scale=1.5)
 bayesfit=rwmetrop(weibullregpost,proposal,fit$mode,10000,d)
 bayesfit$accept

 par(mfrow=c(2,2))
 sigma=exp(bayesfit$par[,1])
 mu=bayesfit$par[,2]
 beta1=bayesfit$par[,3]
 beta2=bayesfit$par[,4]
 hist(beta1,xlab="treatment",main="")
 hist(beta2,xlab="age",main="")
 hist(sigma,xlab="sigma",main="")

#############################################################
# Section 6.10 Analysis of the Stanford Heart Transplant Data
#############################################################

library(LearnBayes)

data(stanfordheart)

 start=c(0,3,-1)
 laplacefit=laplace(transplantpost,start,stanfordheart)
 laplacefit

 proposal=list(var=laplacefit$var,scale=2)
 s=rwmetrop(transplantpost,proposal,start,10000,stanfordheart)
 s$accept

 par(mfrow=c(2,2))
 tau=exp(s$par[,1])
 plot(density(tau),main="TAU")
 lambda=exp(s$par[,2])
 plot(density(lambda),main="LAMBDA")
 p=exp(s$par[,3])
 plot(density(p),main="P")

 apply(exp(s$par),2,quantile,c(.05,.5,.95))

S=readline(prompt="Type  <Return>   to continue : ")

 par(mfrow=c(1,1))
  t=seq(1,240)
 p5=0*t; p50=0*t; p95=0*t
 for (j in 1:240)
 { S=(lambda/(lambda+t[j]))^p
   q=quantile(S,c(.05,.5,.95))
   p5[j]=q[1]; p50[j]=q[2]; p95[j]=q[3]}
 windows()
 plot(t,p50,type="l",ylim=c(0,1),ylab="Prob(Survival)",
   xlab="time")
 lines(t,p5,lty=2)
 lines(t,p95,lty=2)

###############################################
# Section 8.3 A One-Sided Test of a Normal Mean
###############################################

library(LearnBayes)

 pmean=170; pvar=25
 probH=pnorm(175,pmean,sqrt(pvar))
 probA=1-probH
 prior.odds=probH/probA
 prior.odds

 weights=c(182, 172, 173, 176, 176, 180, 173, 174, 179, 175)
 xbar=mean(weights)
 sigma2=3^2/length(weights)

 post.precision=1/sigma2+1/pvar
 post.var=1/post.precision

 post.mean=(xbar/sigma2+pmean/pvar)/post.precision
 c(post.mean,sqrt(post.var))

 post.odds=pnorm(175,post.mean,sqrt(post.var))/
  (1-pnorm(175,post.mean,sqrt(post.var)))
 post.odds

 BF = post.odds/prior.odds
 BF

 postH=probH*BF/(probH*BF+probA)
 postH

 z=sqrt(length(weights))*(mean(weights)-175)/3
 1-pnorm(z)

 weights=c(182, 172, 173, 176, 176, 180, 173, 174, 179, 175)
 data=c(mean(weights),length(weights),3)
 prior.par=c(170,1000)
 mnormt.onesided(175,prior.par,data)

#####################################################
#  Section 7.2  Introduction to Hierarchical Modeling
#####################################################

library(LearnBayes)
library(lattice)

data(sluggerdata)

# fit logistic model for home run data for a particular player

logistic.fit=function(player)
{
d=subset(sluggerdata,Player==player)
x=d$Age; x2=d$Age^2
response=cbind(d$HR, d$AB-d$HR)
list(Age=x, p=glm(response~x+x2,family=binomial)$fitted)
}

names=unique(sluggerdata$Player); newdata=NULL
for (j in 1:9)
{
  fit=logistic.fit(as.character(names[j]))
  newdata=rbind(newdata,data.frame(as.character(names[j]),fit$Age,fit$p))
}
names(newdata)=c("Player","Age","Fitted")
xyplot(Fitted~Age|Player, data=newdata, type="l",lwd=3,col="black")

######################################################
# Section 4.2 Normal Data with Both Parameters Unknown
######################################################

library(LearnBayes)

 data(marathontimes)
 attach(marathontimes)
 d = mycontour(normchi2post, c(220, 330, 500, 9000), time,
    xlab="mean",ylab="variance")

 S = sum((time - mean(time))^2) 
 n = length(time)
 sigma2 = S/rchisq(1000, n - 1)
 mu = rnorm(1000, mean = mean(time), sd = sqrt(sigma2)/sqrt(n))

 points(mu, sigma2)

 quantile(mu, c(0.025, 0.975))

 quantile(sqrt(sigma2), c(0.025, 0.975))

###################################################
# Section 6.9 Modeling Data with Cauchy Errors
###################################################

library(LearnBayes)

 data(darwin)
 attach(darwin)
 mean(difference)

 log(sd(difference))

 laplace(cauchyerrorpost,c(21.6,3.6),difference)

 laplace(cauchyerrorpost,.1*c(21.6,3.6),difference)$mode
 
 c(24.7-4*sqrt(34.96),24.7+4*sqrt(34.96))
 c(2.77-4*sqrt(.138),2.77+4*sqrt(.138))

 mycontour(cauchyerrorpost,c(-10,60,1,4.5),difference,
   xlab="mu",ylab="log sigma")

S=readline(prompt="Type  <Return>   to continue : ")

 fitlaplace=laplace(cauchyerrorpost,c(21.6,3.6), difference)
 windows()
 mycontour(lbinorm,c(-10,60,1,4.5),list(m=fitlaplace$mode,
   v=fitlaplace$var), xlab="mu",ylab="log sigma")

 proposal=list(var=fitlaplace$var,scale=2.5)
 start=c(20,3)
 m=1000
 s=rwmetrop(cauchyerrorpost,proposal,start,m,difference)

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 mycontour(cauchyerrorpost,c(-10,60,1,4.5),difference,
   xlab="mu",ylab="log sigma")
 points(s$par[,1],s$par[,2])

 fitgrid=simcontour(cauchyerrorpost,c(-10,60,1,4.5),difference,
  50000)
 proposal=list(var=fitlaplace$var,scale=2.5)
 start=c(20,3)
 fitrw=rwmetrop(cauchyerrorpost,proposal,start,50000,
   difference)
 proposal2=list(var=fitlaplace$var,mu=t(fitlaplace$mode))
 fitindep=indepmetrop(cauchyerrorpost,proposal2,start,50000,
  difference)
 fitgibbs=gibbs(cauchyerrorpost,start,50000,c(12,.75),
  difference)

 apply(fitrw$par,2,mean)

 apply(fitrw$par,2,sd)

###################################################
# Section 4.3 A Multinomial Model
###################################################

library(LearnBayes)

 alpha = c(728, 584, 138)
 theta = rdirichlet(1000, alpha)

 hist(theta[, 1] - theta[, 2], main="")

S=readline(prompt="Type  <Return>   to continue : ")

###########################################

data(election.2008)
attach(election.2008)

prob.Obama=function(j)
{
p=rdirichlet(5000,
  500*c(M.pct[j],O.pct[j],100-M.pct[j]-O.pct[j])/100+1)
mean(p[,2]>p[,1])
}

Obama.win.probs=sapply(1:51,prob.Obama)

sim.election=function()
{
winner=rbinom(51,1,Obama.win.probs)  
sum(EV*winner)         
}

sim.EV=replicate(1000,sim.election())

windows()
hist(sim.EV,min(sim.EV):max(sim.EV),col="blue")
abline(v=365,lwd=3)  # Obama received 365 votes
text(375,30,"Actual \n Obama \n total")

#############################################
# Section 5.9 Importance Sampling
#############################################

library(LearnBayes)

data(cancermortality)

fit=laplace(betabinexch,c(-7,6),cancermortality)

betabinexch.cond=function (log.K, data)
{
eta = exp(-6.818793)/(1 + exp(-6.818793))
K = exp(log.K)
y = data[, 1]; n = data[, 2]; N = length(y)
logf=0*log.K
for (j in 1:length(y))
logf = logf + lbeta(K * eta + y[j], K * (1 -
eta) + n[j] - y[j]) - lbeta(K * eta, K * (1 - eta))
val = logf + log.K - 2 * log(1 + K)
return(exp(val-max(val)))
}


I=integrate(betabinexch.cond,2,16,cancermortality)
par(mfrow=c(2,2))
curve(betabinexch.cond(x,cancermortality)/I$value,from=3,to=16,
ylab="Density", xlab="log K",lwd=3, main="Densities")
curve(dnorm(x,8,2),add=TRUE)
legend("topright",legend=c("Exact","Normal"),lwd=c(3,1))
curve(betabinexch.cond(x,cancermortality)/I$value/
  dnorm(x,8,2),from=3,to=16, ylab="Weight",xlab="log K",
  main="Weight = g/p")

curve(betabinexch.cond(x,cancermortality)/I$value,from=3,to=16,
   ylab="Density", xlab="log K",lwd=3, main="Densities")
curve(1/2*dt(x-8,df=2),add=TRUE)
legend("topright",legend=c("Exact","T(2)"),lwd=c(3,1))
curve(betabinexch.cond(x,cancermortality)/I$value/
        (1/2*dt(x-8,df=2)),from=3,to=16, ylab="Weight",xlab="log K",
        main="Weight = g/p")

tpar=list(m=fit$mode,var=2*fit$var,df=4)
 myfunc=function(theta)
   return(theta[2])
 s=impsampling(betabinexch,tpar,myfunc,10000,cancermortality)
 cbind(s$est,s$se)

##################################################################
# Section 6.7 Learning about a Normal Population from Grouped Data
##################################################################

library(LearnBayes)

 d=list(int.lo=c(-Inf,seq(66,74,by=2)),
        int.hi=c(seq(66,74,by=2), Inf),
        f=c(14,30,49,70,33,15))

y=c(rep(65,14),rep(67,30),rep(69,49),rep(71,70),rep(73,33),
  rep(75,15))
 mean(y)

 log(sd(y))

 start=c(70,1)
 fit=laplace(groupeddatapost,start,d)
 fit

 modal.sds=sqrt(diag(fit$var))

 proposal=list(var=fit$var,scale=2)
 fit2=rwmetrop(groupeddatapost,proposal,start,10000,d)

 fit2$accept

 post.means=apply(fit2$par,2,mean)
 post.sds=apply(fit2$par,2,sd)

 cbind(c(fit$mode),modal.sds)

 cbind(post.means,post.sds)

 mycontour(groupeddatapost,c(69,71,.6,1.3),d,
    xlab="mu",ylab="log sigma")
 points(fit2$par[5001:10000,1],fit2$par[5001:10000,2])

##############################################
# Section 7.4 Equal Mortality Rates?
##############################################

library(LearnBayes)
data(hearttransplants)
attach(hearttransplants)

sum(y)
sum(e)

 lambda=rgamma(1000,shape=277,rate=294681)
 ys94=rpois(1000,e[94]*lambda)

 hist(ys94,breaks=seq(0.5,max(ys94)+0.5))
 lines(c(y[94],y[94]),c(0,120),lwd=3)

S=readline(prompt="Type  <Return>   to continue : ")

lambda=rgamma(1000,shape=277,rate=294681)
prob.out=function(i)
{
   ysi=rpois(1000,e[i]*lambda)
   pleft=sum(ysi<=y[i])/1000
   pright=sum(ysi>=y[i])/1000
   min(pleft,pright)
 }
pout=sapply(1:94,prob.out)
windows()
plot(log(e),pout,ylab="Prob(extreme)")

################################
# Section 9.2.6 An Example
################################

library(LearnBayes)

 data(birdextinct)
 attach(birdextinct)
 logtime=log(time)
 plot(nesting,logtime)
 out = (logtime > 3)
 text(nesting[out], logtime[out], label=species[out], pos = 2)	

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 plot(jitter(size),logtime,xaxp=c(0,1,1))

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 plot(jitter(status),logtime,xaxp=c(0,1,1))

##### Least-squares fit

 fit=lm(logtime~nesting+size+status,data=birdextinct,x=TRUE,y=TRUE)
 summary(fit)

##### Sampling from posterior

 theta.sample=blinreg(fit$y,fit$x,5000)

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 par(mfrow=c(2,2))
 hist(theta.sample$beta[,2],main="NESTING",
  xlab=expression(beta[1]))
 hist(theta.sample$beta[,3],main="SIZE",
  xlab=expression(beta[2]))
 hist(theta.sample$beta[,4],main="STATUS",
  xlab=expression(beta[3]))
 hist(theta.sample$sigma,main="ERROR SD",
  xlab=expression(sigma))

 apply(theta.sample$beta,2,quantile,c(.05,.5,.95))

 quantile(theta.sample$sigma,c(.05,.5,.95))

S=readline(prompt="Type  <Return>   to continue : ")

###### Estimating mean extinction times

 cov1=c(1,4,0,0)
 cov2=c(1,4,1,0)
 cov3=c(1,4,0,1)
 cov4=c(1,4,1,1)
 X1=rbind(cov1,cov2,cov3,cov4)
 mean.draws=blinregexpected(X1,theta.sample)

 c.labels=c("A","B","C","D")
 windows()
 par(mfrow=c(2,2))
 for (j in 1:4)
   hist(mean.draws[,j],
      main=paste("Covariate set",c.labels[j]),xlab="log TIME")

S=readline(prompt="Type  <Return>   to continue : ")

######## Predicting extinction times

 cov1=c(1,4,0,0)
 cov2=c(1,4,1,0)
 cov3=c(1,4,0,1)
 cov4=c(1,4,1,1)
 X1=rbind(cov1,cov2,cov3,cov4)
 pred.draws=blinregpred(X1,theta.sample)

 c.labels=c("A","B","C","D")
 windows()
 par(mfrow=c(2,2))
 for (j in 1:4)
   hist(pred.draws[,j],
      main=paste("Covariate set",c.labels[j]),xlab="log TIME")

S=readline(prompt="Type  <Return>   to continue : ")

######### Model checking via posterior predictive distribution

 pred.draws=blinregpred(fit$x,theta.sample)
 pred.sum=apply(pred.draws,2,quantile,c(.05,.95))
 par(mfrow=c(1,1))
 ind=1:length(logtime)
 windows()
 matplot(rbind(ind,ind),pred.sum,type="l",lty=1,col=1,
  xlab="INDEX",ylab="log TIME")
 points(ind,logtime,pch=19)
 out=(logtime>pred.sum[2,])
 text(ind[out], logtime[out], label=species[out], pos = 4)

S=readline(prompt="Type  <Return>   to continue : ")

######### Model checking via bayes residuals

 prob.out=bayesresiduals(fit,theta.sample,2)
 windows()
 par(mfrow=c(1,1))
 plot(nesting,prob.out)
 out = (prob.out > 0.35)
 text(nesting[out], prob.out[out], label=species[out], pos = 4)	

#######################################################
# Section 3.6 A Bayesian Test of the Fairness of a Coin
#######################################################

library(LearnBayes)

 pbinom(5, 20, 0.5)

 n = 20
 y = 5
 a = 10
 p = 0.5
 m1 = dbinom(y, n, p) * dbeta(p, a, a)/dbeta(p, a + y, a + n - 
     y)
 lambda = dbinom(y, n, p)/(dbinom(y, n, p) + m1)
 lambda

 pbetat(p,.5,c(a,a),c(y,n-y))

prob.fair=function(log.a)
{
 a = exp(log.a)
 m2 = dbinom(y, n, p) * dbeta(p, a, a)/
             dbeta(p, a + y, a + n - y)
 dbinom(y, n, p)/(dbinom(y, n, p) + m2)
}

n = 20; y = 5; p = 0.5
curve(prob.fair(x), from=-4, to=5, xlab="log a", 
  ylab="Prob(coin is fair)", lwd=2)

S=readline(prompt="Type  <Return>   to continue : ")

 n=20
 y=5
 a=10
 p=.5
 m2=0
 for (k in 0:y)
   m2=m2+dbinom(k,n,p)*dbeta(p,a,a)/dbeta(p,a+k,a+n-k)
 lambda=pbinom(y,n,p)/(pbinom(y,n,p)+m2)
 lambda

###########################################
# Section 4.5 Comparing Two Proportions
###########################################

library(LearnBayes)

 sigma=c(2,1,.5,.25)
 plo=.0001;phi=.9999
 par(mfrow=c(2,2))
 for (i in 1:4)
    mycontour(howardprior,c(plo,phi,plo,phi),c(1,1,1,1,sigma[i]),
      main=paste("sigma=",as.character(sigma[i])),
      xlab="p1",ylab="p2")

S=readline(prompt="Type  <Return>   to continue : ")

 sigma=c(2,1,.5,.25)
 windows()
 par(mfrow=c(2,2))
 for (i in 1:4)
 {
 mycontour(howardprior,c(plo,phi,plo,phi),
   c(1+3,1+15,1+7,1+5,sigma[i]),
   main=paste("sigma=",as.character(sigma[i])),
   xlab="p1",ylab="p2")
 lines(c(0,1),c(0,1))
 }

 s=simcontour(howardprior,c(plo,phi,plo,phi),
   c(1+3,1+15,1+7,1+5,2),1000)
 sum(s$x>s$y)/1000

##############################################
# Section 7.3 Individual or Combined Estimates
##############################################

 library(LearnBayes)
 data(hearttransplants)
 attach(hearttransplants)

 plot(log(e), y/e, xlim=c(6,9.7), xlab="log(e)", ylab="y/e")
 text(log(e),y/e,labels=as.character(y),pos=4)

#########################################################
# Section 5.8 Rejection Sampling
#########################################################

library(LearnBayes)

data(cancermortality)
fit=laplace(betabinexch,c(-7,6),cancermortality)

betabinT=function(theta,datapar)
{
data=datapar$data
tpar=datapar$par
d=betabinexch(theta,data)-dmt(theta,mean=c(tpar$m),
  S=tpar$var,df=tpar$df,log=TRUE)
return(d)
}

tpar=list(m=fit$mode,var=2*fit$var,df=4)
datapar=list(data=cancermortality,par=tpar)

 start=c(-6.9,12.4)
 fit1=laplace(betabinT,start,datapar)
 fit1$mode

 betabinT(fit1$mode,datapar)

 theta=rejectsampling(betabinexch,tpar,-569.2813,10000,cancermortality)
 dim(theta)

 mycontour(betabinexch,c(-8,-4.5,3,16.5),cancermortality,
   xlab="logit eta",ylab="log K")
 points(theta[,1],theta[,2])

#####################################################
# Section 5.4 A Beta-Binomial Model for Overdispersion
#####################################################

 library(LearnBayes)

 data(cancermortality)

 mycontour(betabinexch0,c(.0001,.003,1,20000),cancermortality,
   xlab="eta",ylab="K")

S=readline(prompt="Type  <Return>   to continue : ")

windows()
 mycontour(betabinexch,c(-8,-4.5,3,16.5),cancermortality,
   xlab="logit eta",ylab="log K")

####################################################
# Section 3.4 An Illustration of Bayesian Robustness
####################################################

 library(LearnBayes)

 quantile1=list(p=.5,x=100); quantile2=list(p=.95,x=120)
 normal.select(quantile1, quantile2)

 mu = 100
 tau = 12.16
 sigma = 15
 n = 4
 se = sigma/sqrt(4)
 ybar = c(110, 125, 140)
 tau1 = 1/sqrt(1/se^2 + 1/tau^2)
 mu1 = (ybar/se^2 + mu/tau^2) * tau1^2
 summ1=cbind(ybar, mu1, tau1)
 summ1

 tscale = 20/qt(0.95, 2)
 tscale

 par(mfrow=c(1,1))
 curve(1/tscale*dt((x-mu)/tscale,2),
   from=60, to=140, xlab="theta", ylab="Prior Density")
 curve(dnorm(x,mean=mu,sd=tau), add=TRUE, lwd=3)
 legend("topright",legend=c("t density","normal density"),
   lwd=c(1,3))

S=readline(prompt="Type  <Return>   to continue : ")

 norm.t.compute=function(ybar) {
     theta = seq(60, 180, length = 500)
     like = dnorm(theta,mean=ybar,sd=sigma/sqrt(n))
     prior = dt((theta - mu)/tscale, 2)
     post = prior * like
     post = post/sum(post)
     m = sum(theta * post)
     s = sqrt(sum(theta^2 * post) - m^2)
     c(ybar, m, s) }

summ2=t(sapply(c(110, 125, 140),norm.t.compute))
dimnames(summ2)[[2]]=c("ybar","mu1 t","tau1 t")
summ2

 cbind(summ1,summ2)

 theta=seq(60, 180, length=500)
 normpost = dnorm(theta, mu1[3], tau1)
 normpost = normpost/sum(normpost)
 windows()
 plot(theta,normpost,type="l",lwd=3,ylab="Posterior Density")
 like = dnorm(theta,mean=140,sd=sigma/sqrt(n))
 prior = dt((theta - mu)/tscale, 2)
 tpost = prior * like / sum(prior * like)  
 lines(theta,tpost)
 legend("topright",legend=c("t prior","normal prior"),lwd=c(1,3))

###################################################
# Section 8.7  Is a Baseball Hitter Really Streaky?
###################################################

library(LearnBayes)

 data(jeter2004)
 attach(jeter2004)
 data=cbind(H,AB)
 data1=regroup(data,5)

 log.marg=function(logK) 
     laplace(bfexch,0,list(data=data1,K=exp(logK)))$int
 
 log.K=seq(2,6)
 K=exp(log.K)
 log.BF=sapply(log.K,log.marg)
 BF=exp(log.BF)
 round(data.frame(log.K,K,log.BF,BF),2)

# Chapter 1.3 R commands

# Section 1.3.2

x=rnorm(10,mean=50,sd=10)
y=rnorm(10,mean=50,sd=10)
m=length(x)
n=length(y)
sp=sqrt(((m-1)*sd(x)^2+(n-1)*sd(y)^2)/(m+n-2))
t.stat=(mean(x)-mean(y))/(sp*sqrt(1/m+1/n))

tstatistic=function(x,y)
{
m=length(x)
n=length(y)
sp=sqrt(((m-1)*sd(x)^2+(n-1)*sd(y)^2)/(m+n-2))
t.stat=(mean(x)-mean(y))/(sp*sqrt(1/m+1/n))
return(t.stat)
}

data.x=c(1,4,3,6,5)
data.y=c(5,4,7,6,10)
tstatistic(data.x, data.y)

S=readline(prompt="Type  <Return>   to continue : ")

# Section 1.3.3

# simulation algorithm for normal populations

alpha=.1; m=10; n=10 # sets alpha, m, n
N=10000 # sets the number of simulations
n.reject=0 # counter of num. of rejections
for (i in 1:N)
{
x=rnorm(m,mean=0,sd=1) # simulates xs from population 1
y=rnorm(n,mean=0,sd=1) # simulates ys from population 2
t.stat=tstatistic(x,y) # computes the t statistic
if (abs(t.stat)>qt(1-alpha/2,n+m-2))
   n.reject=n.reject+1 # reject if |t| exceeds critical pt
}
true.sig.level=n.reject/N # est. is proportion of rejections

s=readline(prompt="Type  <Return>   to continue : ")

# simulation algorithm for normal and exponential populations
# storing the values of the t statistic in vector tstat

m=10; n=10 
my.tsimulation=function()
  tstatistic(rnorm(m,mean=10,sd=2), rexp(n,rate=1/10))
tstat.vector=replicate(10000, my.tsimulation())

plot(density(tstat.vector),xlim=c(-5,8),ylim=c(0,.4),lwd=3)
curve(dt(x,df=18),add=TRUE)

#############################################################
# Section 10.3  Binary Response Regression with a Probit Link
#############################################################

#################################################
# Section 10.3.1. Missing data and Gibbs sampling
#################################################

library(LearnBayes)

 data(donner)
 attach(donner)
 X=cbind(1,age,male)

 fit=glm(survival~X-1,family=binomial(link=probit))
 summary(fit)

 m=10000
 fit=bayes.probit(survival,X,m)

 apply(fit$beta,2,mean)

 apply(fit$beta,2,sd)

 a=seq(15,65)
 X1=cbind(1,a,1)
 p.male=bprobit.probs(X1,fit$beta)

 plot(a,apply(p.male,2,quantile,.5),type="l",ylim=c(0,1),
   xlab="age",ylab="Probability of Survival")
 lines(a,apply(p.male,2,quantile,.05),lty=2)
 lines(a,apply(p.male,2,quantile,.95),lty=2)

S=readline(prompt="Type  <Return>   to continue : ")

###################################################
# Section 10.3.2  Proper priors and model selection
###################################################

library(LearnBayes)
data(donner)
y=donner$survival
X=cbind(1,donner$age,donner$male)

beta0=c(0,0,0); c0=100
P0=t(X)%*%X/c0

bayes.probit(y,X,1000,list(beta=beta0,P=P0))$log.marg

bayes.probit(y,X[,-2],1000,
   list(beta=beta0[-2],P=P0[-2,-2]))$log.marg

bayes.probit(y,X[,-3],1000,
   list(beta=beta0[-3],P=P0[-3,-3]))$log.marg

bayes.probit(y,X[,-c(2,3)],1000,
   list(beta=beta0[-c(2,3)],P=P0[-c(2,3),-c(2,3)]))$log.marg

##############################################
# Section 9.3 Modeling Using Zellner's g Prior
##############################################

library(LearnBayes)

# illustrating the role of the parameter c

data(puffin)
X=cbind(1, puffin$Distance - mean(puffin$Distance))
c.prior=c(0.1,0.5,5,2)
fit=vector("list",4)
for (j in 1:4)
{
  prior=list(b0=c(8,0), c0=c.prior[j])
  fit[[j]]=blinreg(puffin$Nest, X, 1000, prior)
}
BETA=NULL
for (j in 1:4)
  {
  s=data.frame(Prior=paste("c =",as.character(c.prior[j])),
         beta0=fit[[j]]$beta[,1],beta1=fit[[j]]$beta[,2])
  BETA=rbind(BETA,s)
  }

with(BETA,lattice::xyplot(beta1~beta0|Prior,type=c("p","g"),col="black"))

S=readline(prompt="Type  <Return>   to continue : ")

# model selection

data=list(y=puffin$Nest, X=cbind(1,puffin$Grass,puffin$Soil))
prior=list(b0=c(0,0,0), c0=100)
beta.start=with(puffin,lm(Nest~Grass+Soil)$coef)
laplace(reg.gprior.post,c(beta.start,0),list(data=data,prior=prior))$int

X=puffin[,-1]; y=puffin$Nest; c=100
bayes.model.selection(y,X,c,constant=FALSE)

##########################################################
# Section 7.8  Posterior Inferences
##########################################################

 library(LearnBayes)
 data(hearttransplants)
 attach(hearttransplants)

 datapar = list(data = hearttransplants, z0 = 0.53)
 start=c(2, -7)
 fit = laplace(poissgamexch, start, datapar)
 fit

 par(mfrow = c(1, 1))
 mycontour(poissgamexch, c(0, 8, -7.3, -6.6), datapar,
   xlab="log alpha",ylab="log mu")

S=readline(prompt="Type  <Return>   to continue : ")

 start = c(4, -7)
 fitgibbs = gibbs(poissgamexch, start, 1000, c(1,.15), datapar)

alpha = exp(fitgibbs$par[, 1])
 mu = exp(fitgibbs$par[, 2])

shrink=function(i) mean(alpha/(alpha + e[i] * mu))
 shrinkage=sapply(1:94, shrink)

S=readline(prompt="Type  <Return>   to continue : ")

 windows()
 plot(log(e), shrinkage)

 mrate=function(i) mean(rgamma(1000, y[i] + alpha, e[i] + alpha/mu))
 hospital=1:94
 meanrate=sapply(hospital,mrate)
 hospital[meanrate==min(meanrate)]

###########################################################

sim.lambda=function(i) rgamma(1000,y[i]+alpha,e[i]+alpha/mu)
LAM=sapply(1:94,sim.lambda)

compare.rates <- function(x) {
  nc <- NCOL(x)
  ij <- as.matrix(expand.grid(1:nc, 1:nc))
  m <- as.matrix(x[,ij[,1]] > x[,ij[,2]]) 
  matrix(colMeans(m), nc, nc, byrow = TRUE)
}

better=compare.rates(LAM)

better[1:24,85]

#######################################################
# Section 3.5 Mixtures of Conjugate Priors
#######################################################

library(LearnBayes)

curve(.5*dbeta(x, 6, 14) + .5*dbeta(x, 14, 6), from=0, to=1,
  xlab="P", ylab="Density")

S=readline(prompt="Type  <Return>   to continue : ")

probs=c(.5,.5)
beta.par1=c(6, 14)
beta.par2=c(14, 6)
betapar=rbind(beta.par1, beta.par2)
data=c(7,3)
post=binomial.beta.mix(probs,betapar,data)
post

windows()
curve(post$probs[1]*dbeta(x,13,17)+post$probs[2]*dbeta(x,21,9),
  from=0, to=1, lwd=3, xlab="P", ylab="DENSITY")
curve(.5*dbeta(x,6,12)+.5*dbeta(x,12,6),0,1,add=TRUE)
legend("topleft",legend=c("Prior","Posterior"),lwd=c(1,3))

betabinexch0=function (theta, data) 
{
    eta = theta[1]
    K = theta[2]
    y = data[, 1]
    n = data[, 2]
    N = length(y)

    logf=function(y,n,K,eta)
       lbeta(K * eta + y, K * (1 - eta) + n - y)-lbeta(K * eta, K * (1 - eta))

    val=sum(logf(y,n,K,eta))

    val = val - 2 * log(1 + K) - log(eta) - log(1 - eta)
    return(val)
}

normpostpred=function(parameters,sample.size,f=min)
{
  normalsample=function(j,parameters,sample.size)
    rnorm(sample.size,mean=parameters$mu[j],sd=sqrt(parameters$sigma2[j]))
  
  m=length(parameters$mu)
  post.pred.samples=sapply(1:m,normalsample,parameters,sample.size)

  stat=apply(post.pred.samples,2,f)

  return(stat)
}

hiergibbs=function(data,m)
{
###############################################################
# Implements Gibbs sampling algorithm for posterior of table
# of means with hierarchical regression prior
#
# INPUT
# data:  40 by 4 matrix where the observed sample means are
#        in column 1, sample sizes are in column 2, and values of
#        two covariates in columns 3 and 4.
# m:  number of cycles of Gibbs sampling
#
# OUTPUT
# a list with 
# -- beta: matrix of simulated values of beta with each row a simulated value
# -- mu:  matrix of simulated values of cell means
# -- var:  vector of simulated values of second-stage variance sigma^2_pi
###############################################################

y=data[,1]               #
n=data[,2]               #  
x1=data[,3]              #
x2=data[,4]              # defines variables y,n,x1,x2,a 
X=cbind(1+0*x1,x1,x2)    #
s2=.65^2/n               #
p=3; N=length(y)         #

mbeta=array(0,c(m,p))        #
mmu=array(0,c(m,length(n)))  #  sets up arrays to store simulated draws
ms2pi=array(0,c(m,1))        #

########################################  defines prior parameters
b1=array(c(.55,.018,.033),c(3,1))
bvar=array(c(8.49e-03,-1.94e-05, -2.88e-04, -1.94e-05,  7.34e-07, -1.52e-06, -2.88e-04,-1.52e-06,  1.71e-05),c(3,3))
ibvar=solve(bvar)
s=.02; v=16;

mu=y; s2pi=.006  # starting values of mu and s2pi in Gibbs sampling

for (j in 1:m)
{
pvar=solve(ibvar+t(X)%*%X/s2pi)                         #
pmean=pvar%*%(ibvar%*%b1+t(X)%*%mu/s2pi)                #  simulates beta
beta=t(chol(pvar))%*%array(rnorm(p),c(p,1))+pmean       #

s2pi=(sum((mu-X%*%beta)^2)/2+s/2)/rgamma(1,shape=(N+v)/2)  #  simulates s2pi

postvar=1/(1/s2+1/s2pi)                #
postmean=(y/s2+X%*%beta/s2pi)*postvar  #  simulates mu
mu=rnorm(n,postmean,sqrt(postvar))     #

mbeta[j,]=t(beta)   #
mmu[j,]=t(mu)       #  stores simulated draws
ms2pi[j]=s2pi       #
}

return(list(beta=mbeta,mu=mmu,var=ms2pi))

}

mnormt.onesided=function(m0,normpar,data)
{
#
# mnormt.onesided Performs a test that a normal mean is <= certain value.
#    m0 = value to be tested
#    normpar = mean and standard deviation of normal prior on mu
#    data = (sample mean, sample size, known sampling standard deviation)

xbar=data[1]; n=data[2]; s=data[3]
prior.mean=normpar[1]
prior.sd=normpar[2]
prior.var=prior.sd^2

priorH=pnorm(m0,prior.mean,prior.sd)
priorA=1-priorH
prior.odds=priorH/priorA

post.precision=1/prior.var+n/s^2
post.var=1/post.precision
post.sd=sqrt(post.var)
post.mean=(xbar*n/s^2+prior.mean/prior.var)/post.precision
postH=pnorm(m0,post.mean,post.sd)
postA=1-postH
post.odds=postH/postA
BF=post.odds/prior.odds

return(list(BF=BF,prior.odds=prior.odds,post.odds=post.odds,postH=postH))
}

"pdiscp" <-
function(p,probs,n,s)
{
#
# PDISCP Predictive distribution of number of successes in future binomial
#  experiment with a discrete prior. PRED = PDISCP(P,PROBS,N,S) returns 
#  vector PRED of predictive probabilities, where P is the vector of 
#  values of the proportion, PROBS is the corresponding vector of
#  probabilities, N is the future binomial sample size, and S is the vector of
#  numbers of successes for which predictive probabilities will be computed.
#------------------------
# Written by Jim Albert
# albert@bgnet.bgsu.edu
# November 2004
#------------------------

pred=0*s;

for (i in 1:length(p))
{
 pred=pred+probs[i]*dbinom(s,n,p[i]);
}
return(pred)
}

plot.bayes2=function(x,marginal=0,...)
if(marginal==0)image(as.numeric(dimnames(x$prob)[[1]]),
as.numeric(dimnames(x$prob)[[2]]),x$prob,
col=gray(1-(0:32)/32),...) else
if(marginal==1) barplot(apply(x$prob,1,sum),...) else
barplot(apply(x$prob,2,sum),...)

normal.normal.mix=function(probs,normalpar,data)
{
N=length(probs)
y=data[1]; sigma2=data[2]
prior.mean=normalpar[,1]
prior.var=normalpar[,2]
post.precision=1/prior.var+1/sigma2
post.var=1/post.precision
post.mean=(y/sigma2+prior.mean/prior.var)/post.precision

m.prob=dnorm(y,prior.mean,sqrt(sigma2+prior.var))
post.probs=probs*m.prob/sum(probs*m.prob)
return(list(probs=post.probs,normalpar=cbind(post.mean,post.var)))
}

 poissgamexch=function (theta, datapar)
{
    y = datapar$data[, 2]
    e = datapar$data[, 1]
    z0 = datapar$z0
    alpha = exp(theta[1])
    mu = exp(theta[2])
    beta = alpha/mu
 
    logf=function(y,e,alpha,beta)
       lgamma(alpha + y) - (y + alpha) * log(e + beta) +
            alpha * log(beta)-lgamma(alpha)

    val=sum(logf(y,e,alpha,beta))
    val = val + log(alpha) - 2 * log(alpha + z0)
    return(val)
}

"pdisc" <-
function(p,prior,data)
{ 
# PDISC Posterior distribution for a proportion with discrete models.
#  POST = PDISC(P,PRIOR,DATA) returns a vector of posterior probabilities.
#  P is the vector of values of the proportion, PRIOR is the corresponding
#  vector of prior probabilities and DATA is the vector of data (number of
#  successes and failures in set of independent Bernoulli trials
#------------------------
# Written by Jim Albert
# albert@bgnet.bgsu.edu
# November 2004
#------------------------

s=data[1]; f=data[2]
p1=p+.5*(p==0)-.5*(p==1)

like=s*log(p1)+f*log(1-p1)
like=like*(p>0)*(p<1)-999*((p==0)*(s>0)+(p==1)*(f>0))
like=exp(like-max(like))

product=like*prior
post=product/sum(product)

return(post)
}

logpoissgamma=function(theta,datapar)
{
y=datapar$data
npar=datapar$par
lambda=exp(theta)
loglike=log(dgamma(lambda,shape=sum(y)+1,rate=length(y)))
logprior=log(dgamma(lambda,shape=npar[1],rate=npar[2])*lambda)
return(loglike+logprior)
}

bayes.probit=function (y, X, m, prior = list(beta = 0, P = 0)) 
{
    rtruncated = function(n, lo, hi, pf, qf, ...) qf(pf(lo, ...) + 
        runif(n) * (pf(hi, ...) - pf(lo, ...)), ...)
    if (sum(prior$P)==0) log.marg=NULL
    beta0 = prior$beta
    BI = prior$P
    N = length(y)
    fit = glm(y ~ X - 1, family = binomial(link = probit))
    beta.s = fit$coef
    p = length(beta.s)
    beta = array(beta.s, c(p, 1))
    beta0 = array(beta0, c(p, 1))
    BI = array(BI, c(p, p))
    Mb = array(0, dim = c(m, p))
    lo = c(-Inf, 0)
    hi = c(0, Inf)
    LO = lo[y + 1]
    HI = hi[y + 1]
    postvar=solve(BI + t(X) %*% X)
    aa = chol(postvar)
    BIbeta0 = BI %*% beta0
    post.ord=0
    for (i in 1:m) {
        z = rtruncated(N, LO, HI, pnorm, qnorm, X %*% beta, 1)
        mn = solve(BI + t(X) %*% X, BIbeta0 + t(X) %*% z)
        beta = t(aa) %*% array(rnorm(p), c(p, 1)) + mn
        post.ord=post.ord+dmnorm(beta.s,mn,postvar)
        Mb[i, ] = beta
    }
    if (sum(BI)>0)
    {
    log.f=sum(y*log(fit$fitted)+(1-y)*log(1-fit$fitted))
    log.g=dmnorm(beta.s,beta0,solve(BI),log=TRUE)
    log.marg=log.f+log.g-log(post.ord/m)
    }
    return(list(beta=Mb,log.marg=log.marg))
}

discrete.bayes=
function (df, prior, y, ...) 
{
    param = as.numeric(names(prior))
    lk=function(j)
       prod(df(y,param[j],...))
    likelihood=sapply(1:length(param),lk)
    pred = sum(prior * likelihood)
    prob = prior * likelihood/pred
    obj = list(prob = prob, pred = pred)
    class(obj) <- "bayes"
    obj
}

bayes.model.selection=function (y, X, c, constant = TRUE) 
{
    base2 = function(s, k) {
        r = rep(0, k)
        for (j in seq(k, 1, by = -1)) {
            r[j] = floor(s/(2^(j - 1)))
            s = s - r[j] * (2^(j - 1))
        }
        return(r)
    }
    regpost.mod = function(theta, stuff) {
        y = stuff$y
        X = stuff$X
        c = stuff$c
        beta = theta[-length(theta)]
        sigma = exp(theta[length(theta)])
        if (length(beta) > 1) 
            loglike = sum(dnorm(y, mean = X %*% as.vector(beta), 
                sd = sigma, log = TRUE))
        else loglike = sum(dnorm(y, mean = X * beta, sd = sigma, 
            log = TRUE))
        logprior = dmnorm(beta, mean = 0 * beta, varcov = c * 
            sigma^2 * solve(t(X) %*% X), log = TRUE)
        return(loglike + logprior)
    }
    require(LearnBayes)
    X = as.matrix(X)
    if (constant == FALSE) 
        X = cbind(1, X)
    p = dim(X)[2] - 1
    GAM = array(TRUE, c(2^p, p + 1))
    for (k in 1:(2^p)) GAM[k, ] = as.logical(c(1, base2(k - 1, 
        p)))
    gof = rep(0, 2^p)
    converge = rep(TRUE, 2^p)
    for (j in 1:2^p) {
        X0 = X[, GAM[j, ]]
        fit = lm(y ~ 0 + X0)
        beta = fit$coef
        s = sqrt(sum(fit$residuals^2)/fit$df.residual)
        theta = c(beta, log(s))
        S = list(X = X0, y = y, c = c)
        fit = laplace(regpost.mod, theta, S)
        gof[j] = fit$int
        converge[j] = fit$converge
    }
    Prob=exp(gof-max(gof))/sum(exp(gof-max(gof)))
    mod.prob=data.frame(GAM[, -1], round(gof,2), round(Prob,5))
    names(mod.prob)=c(dimnames(X)[[2]][-1],"log.m","Prob")
    return(list(mod.prob=mod.prob, converge = converge))
}

beta.select=function(quantile1,quantile2)
{
betaprior1=function(K,x,p)
# suppose one is given a beta(K*m, K*(1-m)) prior 
# where the pth quantile is given by x
# function outputs the prior mean m
{
m.lo=0; m.hi=1; flag=0
while(flag==0)
{
m0=(m.lo+m.hi)/2
p0=pbeta(x,K*m0,K*(1-m0))
if(p0<p) m.hi=m0 else m.lo=m0
if(abs(p0-p)<.0001) flag=1
}
return(m0)
}

p1=quantile1$p; x1=quantile1$x
p2=quantile2$p; x2=quantile2$x

logK=seq(-3,8,length=100); K=exp(logK)
m=sapply(K,betaprior1,x1,p1)

prob2=pbeta(x2,K*m, K*(1-m))
ind=((prob2>0)&(prob2<1))
app=approx(prob2[ind],logK[ind],p2)
K0=exp(app$y)
m0=betaprior1(K0,x1,p1)

return(round(K0*c(m0,(1-m0)),2))
}

pbetap=function(ab,n,s)
{
#
# PBETAP Predictive distribution of number of successes in future binomial
#	experiment with a beta prior. PRED = PBETAP(AB,N,S) returns a vector 
#	PRED of predictive probabilities, where AB is the vector of beta
#	parameters, N is the future binomial sample size, and S is the vector of
#	numbers of successes for which predictive probabilities will be computed.
#------------------------
# Written by Jim Albert
# albert@bgnet.bgsu.edu
# November 2004
#------------------------

pred=0*s;
a=ab[1]; b=ab[2];

lcon=lgamma(n+1)-lgamma(s+1)-lgamma(n-s+1);

pred=exp(lcon+lbeta(s+a,n-s+b)-lbeta(a,b));

return(pred)
}

normnormexch=function(theta,data){
  y=data[,1]
  sigma2=data[,2]
  mu=theta[1]
  tau=exp(theta[2])
  
  logf=function(mu,tau,y,sigma2)
    dnorm(y,mu,sqrt(sigma2+tau^2),log=TRUE)
  
  sum(logf(mu,tau,y,sigma2))+log(tau)
}

mycontour=function (logf, limits, data, ...) 
{
LOGF=function(theta, data)
        {
          if(is.matrix(theta)==TRUE){
          val=matrix(0,c(dim(theta)[1],1))
          for (j in 1:dim(theta)[1])
              val[j]=logf(theta[j,],data)
           } 
          else val=logf(theta,data)
          return(val)
        }
    ng = 50
    x0 = seq(limits[1], limits[2], len = ng)
    y0 = seq(limits[3], limits[4], len = ng)
    X = outer(x0, rep(1, ng))
    Y = outer(rep(1, ng), y0)
    n2 = ng^2
    Z = LOGF(cbind(X[1:n2], Y[1:n2]), data)
    Z = Z - max(Z)
    Z = matrix(Z, c(ng, ng))
    contour(x0, y0, Z, levels = seq(-6.9, 0, by = 2.3), lwd = 2, ...)
}

groupeddatapost=function (theta, data) 
{
    dj=function(f,int.lo,int.hi,mu,sigma)
      f*log(pnorm(int.hi,mu,sigma)-pnorm(int.lo,mu,sigma))
    mu = theta[1]
    sigma = exp(theta[2])
    sum(dj(data$f,data$int.lo,data$int.hi,mu,sigma))
}

rmt=function (n = 1, mean = rep(0, d), S, df = Inf) 
{
    d <- if (is.matrix(S)) 
        ncol(S)
    else 1
    if (df == Inf) 
        x <- 1
    else x <- rchisq(n, df)/df
    z <- rmnorm(n, rep(0, d), S)
    y <- t(mean + t(z/sqrt(x)))
    return(y)
}

simcontour=function (logf, limits, data, m) 
{
LOGF=function(theta, data)
        {
          if(is.matrix(theta)==TRUE){
          val=matrix(0,c(dim(theta)[1],1))
          for (j in 1:dim(theta)[1])
              val[j]=logf(theta[j,],data)
           } 
          else val=logf(theta,data)
          return(val)
        }
    ng = 50
    x0 = seq(limits[1], limits[2], len = ng)
    y0 = seq(limits[3], limits[4], len = ng)
    X = outer(x0, rep(1, ng))
    Y = outer(rep(1, ng), y0)
    n2 = ng^2
    Z = LOGF(cbind(X[1:n2], Y[1:n2]), data)
    Z = Z - max(Z)
    Z = matrix(Z, c(ng, ng))
    d = cbind(X[1:n2], Y[1:n2], Z[1:n2])
    dx = diff(x0[1:2])
    dy = diff(y0[1:2])
    prob = d[, 3]
    prob = exp(prob)
    prob = prob/sum(prob)
    i = sample(2500, m, replace = TRUE, prob = prob)
    return(list(x = d[i, 1] + runif(m) * dx - dx/2, y = d[i, 
        2] + runif(m) * dy - dy/2))
}

rwmetrop=function (logpost, proposal, start, m, ...) 
{
    pb = length(start)
    Mpar = array(0, c(m, pb))
    b = matrix(t(start))
    lb = logpost(start, ...)
    a = chol(proposal$var)
    scale = proposal$scale
    accept = 0
    for (i in 1:m) {
        bc = b + scale * t(a) %*% array(rnorm(pb), c(pb, 1))
        lbc = logpost(t(bc), ...)
        prob = exp(lbc - lb)
        if (is.na(prob) == FALSE) {
            if (runif(1) < prob) {
                lb = lbc
                b = bc
                accept = accept + 1
            }
        }
        Mpar[i, ] = b
    }
    accept = accept/m
    stuff = list(par = Mpar, accept = accept)
    return(stuff)
}

binomial.beta.mix=function(probs,betapar,data)
{
N=length(probs)
s=data[1]; f=data[2]
post.betapar=betapar+outer(rep(1,N),data)
p=post.betapar[,1]/(post.betapar[,1]+post.betapar[,2])
m.prob=exp(dbinom(s,size=s+f,prob=p,log=TRUE)+
  dbeta(p,betapar[,1],betapar[,2],log=TRUE) -
  dbeta(p,post.betapar[,1],post.betapar[,2],log=TRUE))

post.probs=probs*m.prob/sum(probs*m.prob)
return(list(probs=post.probs,betapar=post.betapar))
}

indepmetrop=function (logpost, proposal, start, m, ...) 
{
    logmultinorm = function(x, m, v) {
        return(-0.5 * t(x - m) %*% solve(v) %*% (x - m))
    }
    pb = length(start)
    Mpar = array(0, c(m, pb))
    mu = matrix(proposal$mu)
    if(diff(dim(mu))>0) mu=t(mu)
    v = proposal$var
    a = chol(v)
    f0 = logpost(start, ...)
    th0 = matrix(t(start))
    accept = 0
    for (i in 1:m) {
        th1 = mu + t(a) %*% array(rnorm(pb), c(pb, 1))
        f1 = logpost(t(th1), ...)
        R = exp(logmultinorm(th0, mu, v) - logmultinorm(th1, 
            mu, v) + f1 - f0)
        u = runif(1) < R
        if (u == 1) {
            th0 = th1
            f0 = f1
        }
        Mpar[i, ] = th0
        accept = accept + u
    }
    accept = accept/m
    return(list(par = Mpar, accept = accept))
}

predplot=function(prior,n,yobs)
{
	y=0:n; a=prior[1]; b=prior[2]
	probs=pbetap(prior,n,y)
      m=max(probs)*1.05
	plot(y,probs,type="h",ylab="Probability",ylim=c(0,m),
 main=paste("Predictive Dist., beta(",a,",",b,") prior, n=",n,
            ", yobs=",yobs),lwd=2,col="blue")
	points(yobs,0,pch=19,cex=2.5,col="red")
      text(yobs,m/8,"yobs",col="red")}

mnormt.twosided <-
function (m0, prob, t, data) 
{
    xbar = data[1]
    n = data[2]
    h = data[3]
    num = 0.5 * log(n) - log(h) - 0.5 * n/h^2 * (xbar - m0)^2
    den = -0.5 * log(h^2/n + t^2) - 0.5/(h^2/n + t^2) * (xbar - 
        m0)^2
    bf = exp(num - den)
    post = prob * bf/(prob * bf + 1 - prob)
    return(list(bf = bf, post = post))
}

prior.two.parameters = function(parameter1, parameter2) {
  prior = matrix(1, length(parameter1), length(parameter2))
  prior = prior/sum(prior)
  dimnames(prior)[[1]] = parameter1
  dimnames(prior)[[2]] = parameter2
  prior
 }

logctablepost=function (theta, data) 
{
    theta1 = theta[1]
    theta2 = theta[2]
    s1 = data[1]
    f1 = data[2]
    s2 = data[3]
    f2 = data[4]
    logitp1 = (theta1 + theta2)/2
    logitp2 = (theta2 - theta1)/2
    term1 = s1 * logitp1 - (s1 + f1) * log(1 + exp(logitp1))
    term2 = s2 * logitp2 - (s2 + f2) * log(1 + exp(logitp2))
    return(term1 + term2)
}

bayesresiduals=function(lmfit,post,k)
{
ehat=lmfit$residuals
h=hat(model.matrix(lmfit))

prob=0*ehat
for (i in 1:length(prob))
{
z1=(k-ehat[i]/post$sigma)/sqrt(h[i])
z2=(-k-ehat[i]/post$sigma)/sqrt(h[i])
prob[i]=mean(1-pnorm(z1)+pnorm(z2))
}
return(prob)
}

dmnorm=function (x, mean = rep(0, d), varcov, log = FALSE) 
{
    d <- if (is.matrix(varcov)) 
        ncol(varcov)
    else 1
    if (d > 1 & is.vector(x)) 
        x <- matrix(x, 1, d)
    n <- if (d == 1) 
        length(x)
    else nrow(x)
    X <- t(matrix(x, nrow = n, ncol = d)) - mean
    Q <- apply((solve(varcov) %*% X) * X, 2, sum)
    logDet <- sum(logb(abs(diag(qr(varcov)[[1]]))))
    logPDF <- as.vector(Q + d * logb(2 * pi) + logDet)/(-2)
    if (log) 
        logPDF
    else exp(logPDF)
}

rmnorm=function(n = 1, mean = rep(0, d), varcov) 
{
    d <- if (is.matrix(varcov)) 
        ncol(varcov)
    else 1
    z <- matrix(rnorm(n * d), n, d) %*% chol(varcov)
    y <- t(mean + t(z))
    return(y)
}

transplantpost=function (theta, data) 
{
    x = data[, 1]
    y = data[, 3]
    t = data[, 2]
    d = data[, 4]
    tau = exp(theta[1])
    lambda = exp(theta[2])
    p = exp(theta[3])

    xnt = x[t == 0]
    dnt = d[t == 0]
    z = x[t == 1]
    y = y[t == 1]
    dt = d[t == 1]

    logf=function(xnt,dnt,lambda,p)
      (dnt==0)*(p*log(lambda)+log(p)- (p + 1) * log(lambda + xnt)) +
      (dnt==1)*p*log(lambda/(lambda + xnt))

    logg=function(z,y,tau,lambda,p)
      (dt==0)*(p * log(lambda) + 
       log(p * tau)-(p + 1) * log(lambda + y + tau * z)) + 
        (dt==1) * p * log(lambda/(lambda + y + tau * z))

    val=sum(logf(xnt,dnt,lambda,p))+sum(logg(z,y,tau,lambda,p))
    
    val = val + theta[1] + theta[2] + theta[3]
    return(val)
}

"discint" <-
function(dist,prob)
#
# DISC_INT Computes a highest probability interval for a discrete distribution.  
#	LIST=DISCINT(DIST,PROB) gives a list, where LIST.set is the set of values and
# 	LIST.prob is the exact probability context EPROB, where DIST=[VALUE,PROBABILITY]
#	is the matrix which contains the discrete distribution and PROB
#	is the probability content desired.
#------------------------
# Written by Jim Albert
# albert@bgnet.bgsu.edu
# November 2004
#------------------------
{	
x=dist[,1]; p=dist[,2]; n=length(x)

sp=sort(p,index.return=TRUE)
ps=sp$x
i=sp$ix[seq(n,1,-1)]; ps=p[i]; xs=x[i]
cp=cumsum(ps)
ii=1:n
j=ii[cp>=prob]; j=j[1]
eprob=cp[j]; set=sort(xs[1:j])
v=list(prob=eprob,set=set)
return(v)
}

howardprior=function (xy, par) 
{
    alpha = par[1]
    beta = par[2]
    gam = par[3]
    delta = par[4]
    sigma = par[5]
    p1 = xy[1]
    p2 = xy[2]
    u = log(p1/(1 - p1) * (1 - p2)/p2)/sigma
    z = -0.5 * u^2 + (alpha - 1) * log(p1) + (beta - 1) * log(1 - 
        p1) + (gam - 1) * log(p2) + (delta - 1) * log(1 - p2)
    return(z)
}

regroup=function(data,g)
{
d=dim(data); n=d[1]; m=d[2]
N=floor(n/g)
dataG=array(0,c(N,m))
k=0
for (j in seq(1,(N-1)*g+1,g))
{
k=k+1
for (i in 0:(g-1)) 
  dataG[k,]=dataG[k,]+data[j+i,]
}
if (n>N*g)
{
for (i in (N*g+1):n)
  dataG[N,]=dataG[N,]+data[i,]
}
return(dataG)
}

gibbs=function(logpost,start,m,scale,...)
{ 
p=length(start)
vth=array(0,dim=c(m,p))
f0=logpost(start,...)
arate=array(0,dim=c(1,p))

th0=start
for (i in 1:m)
{
  for (j in 1:p)
  {
  th1=th0
  th1[j]=th0[j]+rnorm(1)*scale[j]
  f1=logpost(th1,...)
  u=runif(1)<exp(f1-f0)
  th0[j]=th1[j]*(u==1)+th0[j]*(u==0)
  f0=f1*(u==1)+f0*(u==0)
  vth[i,j]=th0[j]; 
  arate[j]=arate[j]+u
  }
}
arate=arate/m
stuff=list(par=vth,accept=arate)
return(stuff)
}

pbetat=function(p0,prob,ab,data)
{
#
# PBETAT Performs a test that a proportion is equal to a specific value.
#	PBETAT(P0,PROB,AB,DATA) gives a vector of the Bayes factor and
#	the probability of the hypothesis P=P0, where P0 is the proportion
#	value to be tested, PROB is the prior probability of the hypothesis,
#	AB is the vector of parameters of the beta density under the 
#	alternative hypothesis, and DATA is the vector of numbers of 
#	successes and failures.
#------------------------
# Written by Jim Albert
# albert@bgnet.bgsu.edu
# November 2004
#------------------------

a=ab[1]; b=ab[2]
s=data[1]; f=data[2]

lbf=s*log(p0)+f*log(1-p0)+lbeta(a,b)-lbeta(a+s,b+f)

bf=exp(lbf)
post=prob*bf/(prob*bf+1-prob)

return(list(bf=bf,post=post))

}

discrete.bayes.2=function(df,prior,y=NULL,...)
{
like=function(i,...)
if(is.matrix(y)==TRUE)
df(y[i,],param1,param2,...) else
df(y[i],param1,param2,...)
n.rows=dim(prior)[1]
n.cols=dim(prior)[2]
param1=as.numeric(dimnames(prior)[[1]])
param2=as.numeric(dimnames(prior)[[2]])
param1=outer(param1,rep(1,n.cols))
param2=outer(rep(1,n.rows),param2)
likelihood=1
if(length(y)>0)
{
n=ifelse(is.matrix(y)==FALSE,length(y),dim(y)[1])
for(j in 1:n)
likelihood=likelihood*like(j,...)
}
product=prior*likelihood
pred=sum(prior*likelihood)
prob=prior*likelihood/pred
obj=list(prob=prob,pred=pred)
class(obj)<-"bayes2"
obj
}

logisticpost=function (beta, data) 
{
    x = data[, 1]
    n = data[, 2]
    y = data[, 3]

    beta0 = beta[1]
    beta1 = beta[2]
    
    logf=function(x,n,y,beta0,beta1)
    {  lp = beta0 + beta1 * x
       p = exp(lp)/(1 + exp(lp))
       y * log(p) + (n - y) * log(1 - p)
     }

    return(sum(logf(x,n,y,beta0,beta1)))
}

ctable=function(y,a)
#
# C_TABLE Bayes factor for testing independence in a contingency table.
#	BF=C_TABLE(Y,A) returns the Bayes factor BF against independence in a 
#	2-way contingency table using uniform priors, where Y is a matrix
#	containing the 2-way table, and A is a matrix of prior parameters
#------------------------
# Written by Jim Albert
# albert@bgnet.bgsu.edu
# November 2004
#------------------------
{
ldirich=function(a)
{
val=sum(lgamma(a))-lgamma(sum(a))
return(val)
}
ac=colSums(a); ar=rowSums(a)
yc=colSums(y); yr=rowSums(y)

d=dim(y); oc=1+0*yc; or=1+0*yr; I=d[1];J=d[2]

lbf=ldirich(c(y)+c(a))+ldirich(ar-(J-1)*or)+ldirich(ac-(I-1)*oc)-
    ldirich(c(a))-ldirich(yr+ar-(J-1)*or)-ldirich(yc+ac-(I-1)*oc)

bf=exp(lbf)
return(bf)

}

betabinexch=function (theta, data) 
{
    eta = exp(theta[1])/(1 + exp(theta[1]))
    K = exp(theta[2])
    y = data[, 1]
    n = data[, 2]
    N = length(y)
 
    logf=function(y,n,K,eta)
       lbeta(K * eta + y, K * (1 - eta) + n - y)-lbeta(K * eta, K * (1 - eta))

    val=sum(logf(y,n,K,eta))

    val = val + theta[2] - 2 * log(1 + exp(theta[2]))
    return(val)
}

ordergibbs=function(data,m)
{
# implements Gibbs sampling for table of means
# with prior belief in order restriction
# input:  data = data matrix with two columns [sample mean, sample size]
#         m = number of iterations of Gibbs sampling
# output:  matrix of simulated values of means where each row
#          represents one simulated draw

#####################################################
rnormt=function(n,mu,sigma,lo,hi)
{
# simulates n random variates from a normal(mu,sigma)
# distribution truncated on the interval (lo, hi)

p=pnorm(c(lo,hi),mu,sigma)
return(mu+sigma*qnorm(runif(n)*(p[2]-p[1])+p[1]))
}
#####################################################

y=data[,1]  # sample means
n=data[,2]  # sample sizes
s=.65       # assumed value of sigma for this example
I=8; J=5    # number of rows and columns in matrix

# placing vectors y, n into matrices

y=t(array(y,c(J,I)))
n=t(array(n,c(J,I)))
y=y[seq(8,1,by=-1),]
n=n[seq(8,1,by=-1),]

# setting up the matrix of values of the population means mu
# two rows and two columns are added that help in the simulation
# of individual values of mu from truncated normal distributions

mu0=Inf*array(1,c(I+2,J+2))
mu0[1,]=-mu0[1,]
mu0[,1]=-mu0[,1]
mu0[1,1]=-mu0[1,1]
mu=mu0

# starting value of mu that satisfies order restriction

m1=c(2.64,3.02,3.02,3.07,3.34)
m2=c(2.37,2.63,2.74,2.76,2.91)
m3=c(2.37,2.47,2.64,2.66,2.66)
m4=c(2.31,2.33,2.33,2.33,2.33)
m5=c(2.04,2.11,2.11,2.33,2.33)
m6=c(1.85,1.85,1.85,2.10,2.10)
m7=c(1.85,1.85,1.85,1.88,1.88)
m8=c(1.59,1.59,1.59,1.67,1.88)
muint=rbind(m8,m7,m6,m5,m4,m3,m2,m1)
mu[2:(I+1),2:(J+1)]=muint

MU=array(0,c(m,I*J))  # arry MU stores simulated values of mu

#####################  main loop #######################
for (k in 1:m)
{
	for (i in 2:(I+1))
	{
		for (j in 2:(J+1))
		{
			lo=max(c(mu[i-1,j],mu[i,j-1]))
			hi=min(c(mu[i+1,j],mu[i,j+1]))
			mu[i,j]=rnormt(1,y[i-1,j-1],s/sqrt(n[i-1,j-1]),lo,hi)	
		}
	}
	mm=mu[2:(I+1),2:(J+1)]
	MU[k,]=array(mm,c(1,I*J))
}

return(MU)
}

blinregpred=function(X1,theta.sample)
{
#blinregpred  Produces a simulated sample from the posterior predictive
#             distribution of a linear regression model
#         X1 = design matrix of interest
#         theta.sample = output of blinreg function

d=dim(X1)
n1=d[1]
m=length(theta.sample$sigma)
y1=array(0,c(m,n1))

for (j in 1:n1)
{
y1[,j]=t(X1[j,]%*%t(theta.sample$beta))+rnorm(m)*theta.sample$sigma
}
return(y1)
}

normpostsim=function (data, prior=NULL, m = 1000) 
{

if (length(prior)==0)
{
    S = sum((data - mean(data))^2)
    xbar = mean(data)
    n = length(data)
    SIGMA2 = S/rchisq(m, n - 1)
    MU = rnorm(m, mean = xbar, sd = sqrt(SIGMA2)/sqrt(n))
} else
{
    a=prior$sigma2[1]
    b=prior$sigma2[2]
    mu0=prior$mu[1]
    tau2=prior$mu[2]
    S = sum((data - mean(data))^2)
    xbar = mean(data)
    n = length(data)
 
    SIGMA2=rep(0,m)
    MU=rep(0,m)
    sigma2=S/n
    for (j in 1:m)
    {
    prec=n/sigma2+1/tau2
    mu1=(xbar*n/sigma2+mu0/tau2)/prec
    v1=1/prec
    mu=rnorm(1,mu1,sqrt(v1))

    a1=a+n/2
    b1=b+sum((data-mu)^2)/2
    sigma2=rigamma(1,a1,b1)

    SIGMA2[j]=sigma2
    MU[j]=mu
    }
}
    return(list(mu = MU, sigma2 = SIGMA2))
}

normal.select=function (quantile1, quantile2) 
{
    p1 = quantile1$p
    x1 = quantile1$x
    p2 = quantile2$p
    x2 = quantile2$x
    
    sigma=(x1-x2)/diff(qnorm(c(p2,p1)))
    mu=x1-sigma*qnorm(p1)

    return(list(mu=mu,sigma=sigma))
}

bayes.influence=function(theta,data)
{
y=data[,1]; n=data[,2]
N=length(y)
summary=quantile(theta[,2],c(.05,.5,.95))
summary.obs=array(0,c(N,3))
K=exp(theta[,2])
eta=exp(theta[,1])/(1+exp(theta[,1]))
m=length(K)

for (i in 1:N)
{
  weight=exp(lbeta(K*eta,K*(1-eta))-lbeta(K*eta+y[i],K*(1-eta)+n[i]-y[i]))
  probs=weight/sum(weight)
  indices=sample(1:m,size=m,prob=probs,replace=TRUE)
  theta.s=theta[indices,]
  summary.obs[i,]=quantile(theta.s[,2],c(.05,.5,.95))
}
return(list(summary=summary,summary.obs=summary.obs))
}

careertraj.setup=function(data)
{
Player=data[,1]
player.names=names(table(Player))
N=length(player.names)
m=max(table(Player))
y=array(0,c(N,m))
n=0*y
x=0*y
T=rep(0,N)
for (i in 1:N)
{
   data1=data[Player==player.names[i],]
   nk=dim(data1)
   ni=nk[1]
      for (j in 1:ni)
      {
         y[i,j]=data1[j,10]
         n[i,j]=data1[j,5]-data1[j,13] 
         x[i,j]=data1[j,3]
         T[i]=T[i]+(n[i,j]>0)
      }
}
return(list(player.names=player.names,y=y,n=n,x=x,T=T,N=N))
}

impsampling=function (logf, tpar, h, n, data) 
{
    theta = rmt(n, mean = c(tpar$m), S = tpar$var, df = tpar$df)

    lf=matrix(0,c(dim(theta)[1],1))
    for (j in 1:dim(theta)[1]) lf[j]=logf(theta[j,],data)
    H=lf
    for (j in 1:dim(theta)[1]) H[j]=h(theta[j,])

    lp = dmt(theta, mean = c(tpar$m), S = tpar$var, df = tpar$df, 
        log = TRUE)
    md = max(lf - lp)
    wt = exp(lf - lp - md)
    est = sum(wt * H)/sum(wt)
    SEest = sqrt(sum((H - est)^2 * wt^2))/sum(wt)
    return(list(est = est, se = SEest, theta = theta, wt = wt))
}

poisson.gamma.mix=function(probs,gammapar,data)
{
N=length(probs)
y=data$y; t=data$t; n=length(y)
post.gammapar=gammapar+outer(rep(1,N),c(sum(y),sum(t)))
L=post.gammapar[,1]/post.gammapar[,2]

loglike=0
for (j in 1:n)
  loglike=loglike+dpois(y[j],L*t[j],log=TRUE)

m.prob=exp(loglike+
  dgamma(L,shape=gammapar[,1],rate=gammapar[,2],log=TRUE) -
  dgamma(L,shape=post.gammapar[,1],rate=post.gammapar[,2],log=TRUE))

post.probs=probs*m.prob/sum(probs*m.prob)
return(list(probs=post.probs,gammapar=post.gammapar))
}

normchi2post=function(theta,data)
{
    mu = theta[1]
    sig2 = theta[2]
   
    logf=function(y,mu,sig2)
       -(y-mu)^2/2/sig2-log(sig2)/2

    z=sum(logf(data,mu,sig2))
    z = z - log(sig2)
    return(z)
}

bradley.terry.post=function(theta,data)
{
N=dim(data)[1]; M=length(theta)
sigma=exp(theta[M])
logf=function(k)
{
i=data[k,1]; j=data[k,2]
p=exp(theta[i]-theta[j])/(1+exp(theta[i]-theta[j]))
data[k,3]*log(p)+data[k,4]*log(1-p)
}
sum(sapply(1:N,logf))+sum(dnorm(theta[-M],0,sigma,log=TRUE))
}

dmt=function (x, mean = rep(0, d), S, df = Inf, log = FALSE) 
{
    if (df == Inf) 
        return(dmnorm(x, mean, S, log = log))
    d <- if (is.matrix(S)) 
        ncol(S)
    else 1
    if (d > 1 & is.vector(x)) 
        x <- matrix(x, 1, d)
    n <- if (d == 1) 
        length(x)
    else nrow(x)
    X <- t(matrix(x, nrow = n, ncol = d)) - mean
    Q <- apply((solve(S) %*% X) * X, 2, sum)
    logDet <- sum(logb(abs(diag(qr(S)$qr))))
    logPDF <- (lgamma((df + d)/2) - 0.5 * (d * logb(pi * df) + 
        logDet) - lgamma(df/2) - 0.5 * (df + d) * logb(1 + Q/df))
    if (log) 
        logPDF
    else exp(logPDF)
}

summary.bayes=function(object,coverage=.9,...)
{
x = as.numeric(names(object$prob))
p = object$prob
post.mean=sum(x*p)
post.sd=sqrt(sum((x-post.mean)^2*p))
names(p)=NULL
n = length(x)
sp = sort(p, index.return = TRUE)
ps = sp$x
i = sp$ix[seq(n, 1, -1)]
ps = p[i]
xs = x[i]
cp = cumsum(ps)
ii = 1:n
j = ii[cp >= coverage]
j = j[1]
eprob = cp[j]
set = sort(xs[1:j])
v = list(mean=post.mean,sd=post.sd,coverage = eprob, set = set)
return(v)
}

robustt=function(y,v,m)
{
rigamma=function(n,a,b)
{
# simulates n values from a Inverse Gamma
# distribution with shape a and rate b
# density x^(-a-1) exp(b/x)

return(1/rgamma(n,shape=a,rate=b))
}
n=length(y)
mu=mean(y); sig2=sd(y)^2; lam=array(1,c(n,1))
M=array(0,c(m,1)); S2=M; LAM=array(0,c(m,n))

for (i in 1:m)
{
  lam=rgamma(n,shape=(v+1)/2,rate=v/2+(y-mu)^2/2/sig2)
  mu=rnorm(1,mean=sum(y*lam)/sum(lam),sd=sqrt(sig2/sum(lam)))
  sig2=rigamma(1,n/2,sum(lam*(y-mu)^2)/2)
  M[i]=mu; S2[i]=sig2; LAM[i,]=lam
}
par=list(mu=M,s2=S2,lam=LAM)
return(par)	  			 
}

sir=function (logf, tpar, n, data) 
{
    k = length(tpar$m)
    theta = rmt(n, mean = c(tpar$m), S = tpar$var, df = tpar$df)
    lf=matrix(0,c(dim(theta)[1],1))
    for (j in 1:dim(theta)[1]) lf[j]=logf(theta[j,],data)
    lp = dmt(theta, mean = c(tpar$m), S = tpar$var, df = tpar$df, 
        log = TRUE)
    md = max(lf - lp)
    wt = exp(lf - lp - md)
    probs = wt/sum(wt)
    indices = sample(1:n, size = n, prob = probs, replace = TRUE)
    if (k > 1) 
        theta = theta[indices, ]
    else theta = theta[indices]
    return(theta)
}

bfexch=function (theta, datapar) 
{
    y = datapar$data[, 1]
    n = datapar$data[, 2]
    K = datapar$K
    eta = exp(theta)/(1 + exp(theta))
   
    logf=function(K,eta,y,n)
         lbeta(K*eta+y, K*(1-eta)+n-y)-lbeta(K*eta, K*(1-eta))

    sum(logf(K,eta,y,n)) + log(eta * (1 - eta))-
         lbeta(sum(y) + 1, sum(n - y) + 1)
}

reg.gprior.post=function(theta,dataprior)
{
y=dataprior$data$y; X=dataprior$data$X
c0=dataprior$prior$c0; beta0=dataprior$prior$b0
beta=theta[-length(theta)]; sigma=exp(theta[length(theta)])

loglike=sum(dnorm(y,mean=X%*%as.vector(beta),sd=sigma,log=TRUE))
logprior=dmnorm(beta,mean=beta0,varcov=c0*sigma^2*solve(t(X)%*%X),log=TRUE)
return(loglike+logprior)
}

weibullregpost=function (theta, data) 
{
    logf=function(t,c,x,sigma,mu,beta)
    {
    z=(log(t)-mu-x%*%beta)/sigma
    f=1/sigma*exp(z-exp(z))
    S=exp(-exp(z))
    c*log(f)+(1-c)*log(S)
    }
    
    k = dim(data)[2]
    p = k - 2
    t = data[, 1]
    c = data[, 2]
    X = data[, 3:k]
    sigma = exp(theta[1])
    mu = theta[2]
    beta = array(theta[3:k], c(p,1))
    return(sum(logf(t,c,X,sigma,mu,beta)))
}

blinreg=function (y, X, m, prior=NULL) 
{
    if(length(prior)>0)
      { c0=prior$c0; beta0=matrix(prior$b0,c(1,length(prior$b)))}

    fit = lm(y ~ 0 + X)
    bhat = matrix(fit$coef, c(1, fit$rank))
    s2 = sum(fit$residuals^2)/fit$df.residual

    if(length(prior)==0)
    {
    shape = fit$df.residual/2
    rate = fit$df.residual/2 * s2
    beta.m = bhat
    vbeta = vcov(fit)/s2
    } else
    {
    shape = length(y)/2
    rate = fit$df.residual/2 * s2 + 
         (beta0 - bhat) %*% t(X) %*% X %*% t(beta0 - bhat)/2/(c0+1)
    beta.m = c0/(c0+1)*(beta0/c0 + bhat)
    vbeta = vcov(fit)/s2*c0/(c0+1)
    }

    sigma = sqrt(1/rgamma(m, shape = shape, rate = rate))
    beta = rmnorm(m, mean=rep(0, fit$rank), varcov=vbeta) 
    beta = array(1, c(m, 1)) %*% beta.m +
           array(sigma, c(m, fit$rank))*beta

    return(list(beta = beta, sigma = sigma))
}

logpoissnormal=function(theta,datapar)
{
y=datapar$data
npar=datapar$par
lambda=exp(theta)
loglike=log(dgamma(lambda,shape=sum(y)+1,scale=1/length(y)))
logprior=log(dnorm(theta,mean=npar[1],sd=npar[2]))
return(loglike+logprior)
}

laplace=function (logpost, mode, ...) 
{
    options(warn=-1)
    fit=optim(mode, logpost, gr = NULL, ..., hessian=TRUE,
      control=list(fnscale=-1))
    options(warn=0)
    mode=fit$par
    h=-solve(fit$hessian)
    p=length(mode)
    int = p/2 * log(2 * pi) + 0.5 * log(det(h)) +
        logpost(mode, ...)
    stuff = list(mode = mode, var = h, int = int, 
         converge=fit$convergence==0)   
    return(stuff)
}

triplot=function(prior,data,where="topright")
{
a=prior[1]; b=prior[2]
s=data[1]; f=data[2]

p = seq(0.005, 0.995, length = 500)
prior=dbeta(p,a,b)
like=dbeta(p,s+1,f+1)
post=dbeta(p,a+s, b+f)

m=max(c(prior,like,post))

plot(p,post,type="l", ylab="Density", lty=2, lwd=3,
 main=paste("Bayes Triplot, beta(",a,",",b,") prior, s=",s,", f=",f),
 ylim=c(0,m),col="red")
lines(p,like,lty=1, lwd=3,col="blue")
lines(p,prior,lty=3, lwd=3,col="green")
legend(where,c("Prior","Likelihood","Posterior"),
  lty=c(3,1,2), lwd=c(3,3,3), col=c("green","blue","red"))

}

rejectsampling=function (logf, tpar, dmax, n, data) 
{
    d = length(tpar$m)
    theta = rmt(n, mean = c(tpar$m), S = tpar$var, df = tpar$df)
    lf = matrix(0, c(dim(theta)[1], 1))
    for (j in 1:dim(theta)[1]) lf[j] = logf(theta[j, ], data)
    lg = dmt(theta, mean = c(tpar$m), S = tpar$var, df = tpar$df, 
        log = TRUE)
    if (d == 1) {
        prob = exp(c(lf) - lg - dmax)
        return(theta[runif(n) < prob])
    }
    else {
        prob = exp(lf - lg - dmax)
        return(theta[runif(n) < prob, ])
    }
}

rdirichlet=function (n, par) 
{
    k = length(par)
    z = array(0, dim = c(n, k))
    s = array(0, dim = c(n, 1))
    for (i in 1:k) {
        z[, i] = rgamma(n, shape = par[i])
        s = s + z[, i]
    }
    for (i in 1:k) {
        z[, i] = z[, i]/s
    }
    return(z)
}

bprobit.probs=function(X1,fit)
{
# bprobit.probs  Produces a simulated sample from the posterior 
#             distribution of an expected response for a linear regression model
#         X1 = design matrix of interest
#         fit = output of bayes.probit function

d=dim(X1)
n1=d[1]
md=dim(fit); m=md[1]
m1=array(0,c(m,n1))

for (j in 1:n1)
{
m1[,j]=pnorm(X1[j,]%*%t(fit))
}
return(m1)
}

bfindep=function(y,K,m)
{
# compute Bayes factor against independence
# using Albert and Gupta independence priors
# ymat - I x J matrix
# K - Dirichlet precision parameter
# m - number of iterations

rdirichlet=function (n, alpha) 
{
    l <- length(alpha)
    x <- matrix(rgamma(l * n, alpha), ncol = l, byrow = TRUE)
    sm <- x %*% rep(1, l)
    return(x/as.vector(sm))
}

ldirichlet=function(alpha)
{
# log dirichlet function 
# for multiple values stored in matrix alpha
return(rowSums(lgamma(alpha))-lgamma(rowSums(alpha)))
}

yc=colSums(y); yr=rowSums(y); n=sum(yc)
d=dim(y); I=d[1]; J=d[2]

etaA=rdirichlet(m,yr+1)
etaB=rdirichlet(m,yc+1)

Keta=c(); KetaY=c()
for (i in 1:I)
{
for (j in 1:J)
{
Keta=cbind(Keta,K*etaA[,i]*etaB[,j])
KetaY=cbind(KetaY,K*etaA[,i]*etaB[,j]+y[i,j])
}}

logint=ldirichlet(KetaY)-ldirichlet(Keta)
for (i in 1:I) logint=logint-yr[i]*log(etaA[,i])
for (j in 1:J) logint=logint-yc[j]*log(etaB[,j])

int=exp(logint)
  
return(list(bf=mean(int),nse=sd(int)/sqrt(m)))
}

\name{gibbs}
\alias{gibbs}
\title{Metropolis within Gibbs sampling algorithm of a posterior distribution}
\description{
 Implements a Metropolis-within-Gibbs sampling algorithm for an arbitrary real-valued
posterior density defined by the user
}
\usage{
gibbs(logpost,start,m,scale,...)
}
\arguments{
  \item{logpost}{function defining the log posterior density}
  \item{start}{array with a single row that gives the starting value of the parameter vector}
  \item{m}{the number of iterations of the chain}
  \item{scale}{vector of scale parameters for the random walk Metropolis steps}
  \item{...}{data that is used in the function logpost}
}

\value{
\item{par}{a matrix of simulated values where each row corresponds to a value of the vector parameter}
\item{accept}{vector of acceptance rates of the Metropolis steps of the algorithm}
}

\author{Jim Albert}

\examples{
data=c(6,2,3,10)
start=array(c(1,1),c(1,2))
m=1000
scale=c(2,2)
s=gibbs(logctablepost,start,m,scale,data)
}

\keyword{models}

\name{pbetap}
\alias{pbetap}
\title{Predictive distribution for a binomial sample with a beta prior}
\description{
 Computes predictive distribution for number of successes of
 future binomial experiment
 with a beta prior distribution for the proportion.
}
\usage{
pbetap(ab, n, s)
}
\arguments{
  \item{ab}{vector of parameters of the beta prior}
  \item{n}{size of future binomial sample}
  \item{s}{vector of number of successes for future binomial experiment}
}

\value{
  vector of predictive probabilities for the values in the vector s
}

\author{Jim Albert}

\examples{
ab=c(3,12)
n=10
s=0:10
pbetap(ab,n,s)
}

\keyword{models}

\name{marathontimes}
\alias{marathontimes}
\docType{data}
\title{Marathon running times}
\description{
Running times in minutes for twenty male runners between the ages 20 and 29
who ran the New York Marathon.
}
\usage{
marathontimes
}
\format{
A data frame with 20 observations on the following 1 variable.
 \describe{
  \item{time}{running time}
  }
}
\source{www.nycmarathon.org website.}
\keyword{datasets}

\name{hiergibbs}
\alias{hiergibbs}
\title{Gibbs sampling for a hierarchical regression model}
\description{
 Implements Gibbs sampling for estimating a two-way table of means
under a hierarchical regression model.
}
\usage{
hiergibbs(data,m)
}
\arguments{
  \item{data}{data matrix with columns observed sample means, sample sizes, and values of two covariates}
  \item{m}{number of cycles of Gibbs sampling}
}

\value{
  \item{beta}{matrix of simulated values of regression vector}
  \item{mu}{matrix of simulated values of cell means}
  \item{var}{vector of simulated values of second-stage prior variance}
}

\author{Jim Albert}

\examples{
data(iowagpa)
m=1000
s=hiergibbs(iowagpa,m)
}

\keyword{models}

\name{mnormt.onesided}
\alias{mnormt.onesided}
\title{Bayesian test of one-sided hypothesis about a normal mean}
\description{
Computes a Bayesian test of the hypothesis that a normal mean is 
less than or equal to a specified value}
\usage{
mnormt.onesided(m0,normpar,data)
}
\arguments{
  \item{m0}{value of the normal mean to be tested}
  \item{normpar}{vector of mean and standard deviation of the normal prior distribution}
  \item{data}{vector of sample mean, sample size, and known value of the population standard deviation}
}

\value{
\item{BF}{Bayes factor in support of the null hypothesis}
\item{prior.odds}{prior odds of the null hypothesis}
\item{post.odds}{posterior odds of the null hypothesis}
\item{postH}{posterior probability of the null hypothesis}
}

\author{Jim Albert}

\examples{
y=c(182,172,173,176,176,180,173,174,179,175)
pop.s=3
data=c(mean(y),length(data),pop.s)
m0=175
normpar=c(170,1000)
mnormt.onesided(m0,normpar,data)
}

\keyword{models}

\name{blinregexpected}
\alias{blinregexpected}
\title{Simulates values of expected response for linear regression model}
\description{
Simulates draws of the posterior distribution of an expected response for
a linear regression model with a noninformative prior}
\usage{
blinregexpected(X1,theta.sample)
}
\arguments{
  \item{X1}{matrix where each row corresponds to a covariate set}
  \item{theta.sample}{list with components beta, matrix of simulated draws of regression vector,
and sigma, vector of simulated draws of sampling error standard deviation}
}

\value{
matrix where a column corresponds to the simulated draws of the expected response for a given
covariate set
}

\author{Jim Albert}

\examples{
chirps=c(20,16.0,19.8,18.4,17.1,15.5,14.7,17.1,15.4,16.2,15,17.2,16,17,14.1)
temp=c(88.6,71.6,93.3,84.3,80.6,75.2,69.7,82,69.4,83.3,78.6,82.6,80.6,83.5,76.3)
X=cbind(1,chirps)
m=1000
theta.sample=blinreg(temp,X,m)
covset1=c(1,15)
covset2=c(1,20)
X1=rbind(covset1,covset2)
blinregexpected(X1,theta.sample)
}

\keyword{models}

\name{hearttransplants}
\alias{hearttransplants}
\docType{data}
\title{Heart transplant mortality data}
\description{
The number of deaths within 30 days of heart transplant surgery for 94 U.S. hospitals
that performed at least 10 heart transplant surgeries.  Also the exposure, the expected number of deaths, is 
recorded for each hospital.}

\usage{
hearttransplants
}
\format{
A data frame with 94 observations on the following 2 variables.
  \describe{
  \item{e}{expected number of deaths (the exposure)}
  \item{y}{observed number of deaths within 30 days of heart transplant surgery}
  }
}
\source{Christiansen, C. and Morris, C. (1995), Fitting and checking
a two-level Poisson model:  modeling patient mortality rates in heart
transplant patients, in Berry, D. and Stangl, D., eds, Bayesian
Biostatistics, Marcel Dekker.}

\keyword{datasets}

\name{normal.select}
\alias{normal.select}
\title{Selection of Normal Prior Given Knowledge of Two Quantiles}
\description{
 Finds the mean and standard deviation of a normal density that matches knowledge of
two quantiles of the distribution.
}
\usage{
normal.select(quantile1, quantile2)
}
\arguments{
  \item{quantile1}{list with components p, the value of the first probability,
  and x, the value of the first quantile}
  \item{quantile2}{list with components p, the value of the second probability,
  and x, the value of the second quantile}
}

\value{
\item{mean}{mean of the matching normal distribution}
\item{sigma}{standard deviation of the matching normal distribution}
}

\author{Jim Albert}

\examples{
# person believes the 15th percentile of the prior is 100
# and the 70th percentile of the prior is 150
quantile1=list(p=.15,x=100)
quantile2=list(p=.7,x=150)
normal.select(quantile1,quantile2)
}

\keyword{models}

\name{mycontour}
\alias{mycontour}
\title{Contour plot of a bivariate density function}
\description{
 For a general two parameter density, draws a contour graph where the
contour lines are drawn at 10 percent, 1 percent, and .1 percent of 
the height at the mode.
}
\usage{
mycontour(logf,limits,data,...)
}
\arguments{
  \item{logf}{function that defines the logarithm of the  density}
  \item{limits}{limits (xlo, xhi, ylo, yhi) where the graph is to be drawn}
  \item{data}{vector or list of parameters associated with the function logpost}
  \item{...}{further arguments to pass to contour}
}

\value{
A contour graph of the density is drawn
}

\author{Jim Albert}

\examples{
m=array(c(0,0),c(2,1))
v=array(c(1,.6,.6,1),c(2,2))
normpar=list(m=m,v=v)
mycontour(lbinorm,c(-4,4,-4,4),normpar)
}

\keyword{models}

\name{logpoissgamma}
\alias{logpoissgamma}
\title{Log posterior with Poisson sampling and gamma prior}
\description{
Computes the logarithm of the posterior density of a Poisson log mean
with a gamma prior
}
\usage{
logpoissgamma(theta,datapar)
}
\arguments{
  \item{theta}{vector of values of the log mean parameter}
  \item{datapar}{list with components data, vector of observations, and par, vector of
parameters of the gamma prior}
}

\value{
vector of values of the log posterior for all values in theta
}

\author{Jim Albert}

\examples{
data=c(2,4,3,6,1,0,4,3,10,2)
par=c(1,1)
datapar=list(data=data,par=par)
theta=c(-1,0,1,2)
logpoissgamma(theta,datapar)
}

\keyword{models}

\name{beta.select}
\alias{beta.select}
\title{Selection of Beta Prior Given Knowledge of Two Quantiles}
\description{
 Finds the shape parameters of a beta density that matches knowledge of
two quantiles of the distribution.
}
\usage{
beta.select(quantile1, quantile2)
}
\arguments{
  \item{quantile1}{list with components p, the value of the first probability,
  and x, the value of the first quantile}
  \item{quantile2}{list with components p, the value of the second probability,
  and x, the value of the second quantile}
}

\value{
vector of shape parameters of the matching beta distribution
}

\author{Jim Albert}

\examples{
# person believes the median of the prior is 0.25 
# and the 90th percentile of the prior is 0.45
quantile1=list(p=.5,x=0.25)
quantile2=list(p=.9,x=0.45)
beta.select(quantile1,quantile2)
}

\keyword{models}

\name{cancermortality}
\alias{cancermortality}
\docType{data}
\title{Cancer mortality data}
\description{
Number of cancer deaths and number at risk for 20 cities in Missouri.
}
\usage{
cancermortality
}
\format{
A data frame with 20 observations on the following 2 variables.
  \describe{
  \item{y}{number of cancer deaths}
  \item{n}{number at risk}
  }
}
\source{Tsutakawa, R., Shoop, G., and Marienfeld, C. (1985),
Empirical Bayes Estimation
of Cancer Mortality Rates, Statistics in Medicine, 4, 201-212.
}

\keyword{datasets}

\name{lbinorm}
\alias{lbinorm}
\title{Logarithm of bivariate normal density}
\description{
Computes the logarithm of a bivariate normal density
}
\usage{
lbinorm(xy,par)
}
\arguments{
  \item{xy}{vector of values of two variables x and y}
  \item{par}{list with components m, a vector of means, and v, a variance-covariance matrix}
}

\value{
value of the kernel of the log density
}

\author{Jim Albert}

\examples{
mean=c(0,0)
varcov=diag(c(1,1))
value=c(1,1)
param=list(m=mean,v=varcov)
lbinorm(value,param)
}

\keyword{models}

\name{mnormt.twosided}
\alias{mnormt.twosided}
\title{Bayesian test of a two-sided hypothesis about a normal mean}
\description{
 Bayesian test that a normal mean is equal to a specified
 value using a normal prior}
\usage{
mnormt.twosided(m0, prob, t, data)
}
\arguments{
  \item{m0}{value of the mean to be tested }
  \item{prob}{prior probability of the hypothesis}
  \item{t}{vector of values of the prior standard
  deviation under the alternative hypothesis}
  \item{data}{vector containing the sample mean,
  the sample size, and the known value of the
  population standard deviation}
}

\value{
  \item{bf}{vector of values of the Bayes factor
  in support of the null hypothesis}
  \item{post}{vector of posterior probabilities
  of the null hypothesis}
}

\author{Jim Albert}

\examples{
m0=170
prob=.5
tau=c(.5,1,2,4,8)
samplesize=10
samplemean=176
popsd=3
data=c(samplemean,samplesize,popsd)
mnormt.twosided(m0,prob,tau,data)
}

\keyword{models}

\name{triplot}
\alias{triplot}
\title{Plot of prior, likelihood and posterior for a proportion}
\description{
For a proportion problem with a beta prior, plots the prior, likelihood and posterior
on one graph.
}
\usage{
triplot(prior,data,where="topright")
}
\arguments{
  \item{prior}{vector of parameters for beta prior}
  \item{data}{vector consisting of number of successes and number of
  failures}
  \item{where}{the location of the legend for the plot}
}

\author{Jim Albert}

\examples{
prior=c(3,10)  # proportion has a beta(3, 10) prior
data=c(10,6)   # observe 10 successes and 6 failures
triplot(prior,data)
}

\keyword{models}

\name{footballscores}
\alias{footballscores}
\docType{data}
\title{Game outcomes and point spreads for American football}
\description{
Game outcomes and point spreads for 672 professional
American football games.
}
\usage{
footballscores
}
\format{
   A data frame with 672 observations on the following 8 variables.
  \describe{
  \item{year}{year of game}
  \item{home}{indicates if favorite is the home team}
  \item{favorite}{score of favorite team}
  \item{underdog}{score of underdog team}
  \item{spread}{point spread}
  \item{favorite.name}{name of favorite team}
  \item{underdog.name}{name of underdog team}
  \item{week}{week number of the season}
  }
}
\source{Gelman, A., Carlin, J., Stern, H., and Rubin, D. (2003),
Bayesian Data Analysis, Chapman and Hall.}
\keyword{datasets}

\name{rwmetrop}
\alias{rwmetrop}
\title{Random walk Metropolis algorithm of a posterior distribution}
\description{
 Simulates iterates of a random walk Metropolis chain for an arbitrary  real-valued
posterior density defined by the user
}
\usage{
rwmetrop(logpost,proposal,start,m,...)
}
\arguments{
  \item{logpost}{function defining the log posterior density}
  \item{proposal}{a list containing var, an estimated variance-covariance matrix, and scale, the Metropolis scale factor} 
  \item{start}{vector containing the starting value of the parameter}
  \item{m}{the number of iterations of the chain}
  \item{...}{data that is used in the function logpost}
}

\value{
\item{par}{a matrix of simulated values where each row corresponds to a value of the vector parameter}
\item{accept}{the acceptance rate of the algorithm}
}

\author{Jim Albert}

\examples{
data=c(6,2,3,10)
varcov=diag(c(1,1))
proposal=list(var=varcov,scale=2)
start=array(c(1,1),c(1,2))
m=1000
s=rwmetrop(logctablepost,proposal,start,m,data)
}

\keyword{models}

\name{poisson.gamma.mix}
\alias{poisson.gamma.mix}
\title{Computes the posterior for Poisson sampling and a mixture of gammas prior}
\description{
 Computes the parameters and mixing probabilities for a Poisson sampling problem
where the prior is a discrete mixture of gamma densities.
} 
\usage{
poisson.gamma.mix(probs,gammapar,data)
}
\arguments{
  \item{probs}{vector of probabilities of the gamma components of the prior}
  \item{gammapar}{matrix where each row contains the shape and rate parameters for a gamma component of the prior}
  \item{data}{list with components y, vector of counts, and t, vector of time intervals}
}

\value{
\item{probs}{vector of  probabilities of the gamma components of the posterior}
\item{gammapar}{matrix where each row contains the shape and rate parameters for a gamma component of the posterior}
}
\author{Jim Albert}

\examples{
probs=c(.5, .5)
gamma.par1=c(1,1)
gamma.par2=c(10,2)
gammapar=rbind(gamma.par1,gamma.par2)
y=c(1,3,2,4,10); t=c(1,1,1,1,1)
data=list(y=y,t=t)
poisson.gamma.mix(probs,gammapar,data)}

\keyword{models}

\name{normnormexch}
\alias{normnormexch}
\title{Log posterior of mean and log standard deviation for Normal/Normal exchangeable model}
\description{
 Computes the log posterior density of mean and log standard deviation for a Normal/Normal exchangeable model where (mean, log sd) is given a uniform prior.
}
\usage{
normnormexch(theta,data)
}
\arguments{
  \item{theta}{vector of parameter values of mu and log tau}
  \item{data}{a matrix with columns y (observations) and v (sampling variances)}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
s.var <- c(0.05, 0.05, 0.05, 0.05, 0.05)
y.means <- c(1, 4, 3, 6,10)
data=cbind(y.means, s.var)
theta=c(-1, 0)
normnormexch(theta,data)
}

\keyword{models}

\name{pdisc}
\alias{pdisc}
\title{Posterior distribution for a proportion with discrete priors}
\description{
Computes the posterior distribution for a proportion for a discrete prior
distribution.
}
\usage{
pdisc(p, prior, data)
}
\arguments{
  \item{p}{vector of proportion values}
  \item{prior}{vector of prior probabilities}
  \item{data}{vector consisting of number of successes and number of
  failures}
}
\value{
  vector of posterior probabilities
}

\author{Jim Albert}

\examples{
p=c(.2,.25,.3,.35)
prior=c(.25,.25,.25,.25)
data=c(5,10)
pdisc(p,prior,data)
}

\keyword{models}

\name{discint}
\alias{discint}
\title{Highest probability interval for a discrete distribution}
\description{
Computes a highest probability interval for a discrete probability
distribution
}
\usage{
discint(dist, prob)
}
\arguments{
  \item{dist}{probability distribution written as a matrix where
  the first column contain the values and the second column 
  the probabilities}
  \item{prob}{probability content of interest}
}

\value{
  \item{prob}{exact probability content of interval}
  \item{set}{set of values of the probability interval}
}
\author{Jim Albert}

\examples{
x=0:10
probs=dbinom(x,size=10,prob=.3)
dist=cbind(x,probs)
pcontent=.8
discint(dist,pcontent)
}
\keyword{models}

\name{dmt}
\alias{dmt}
\title{Probability density function for multivariate t}
\description{
 Computes the density of a multivariate t distribution
}
\usage{
dmt(x, mean = rep(0, d), S, df = Inf, log=FALSE)
}
\arguments{
  \item{x}{vector of length d or matrix with d columns, giving the coordinates of points where density is to evaluated}
  \item{mean}{numeric vector giving the location parameter of the distribution}
  \item{S}{a positive definite matrix representing the scale matrix of the distribution}
  \item{df}{degrees of freedom}
  \item{log}{a logical value; if TRUE, the logarithm of the density is to be computed}
}
\value{
vector of density values
}

\author{Jim Albert}

\examples{
mu <- c(1,12,2)
Sigma <- matrix(c(1,2,0,2,5,0.5,0,0.5,3), 3, 3)
df <- 4
x <- c(2,14,0)
f <- dmt(x, mu, Sigma, df)
}

\keyword{models}

\name{election.2008}
\alias{election.2008}
\docType{data}
\title{Poll data from 2008 U.S. Presidential Election}
\description{
Results of recent state polls in the 2008 United States Presidential
Election between Barack Obama and John McCain.
}
\usage{
election.2008
}
\format{
  A data frame with 51 observations on the following 4 variables.
  \describe{
  \item{State}{name of the state}
  \item{M.pct}{percentage of poll survey for McCain}
  \item{O.pct}{precentage of poll survey for Obama}
  \item{EV}{number of electoral votes}
  }
}
\source{Data collected by author in November 2008 from www.cnn.com website.}
\keyword{datasets}

\name{binomial.beta.mix}
\alias{binomial.beta.mix}
\title{Computes the posterior for binomial sampling and a mixture of betas prior}
\description{
 Computes the parameters and mixing probabilities for a binomial sampling problem
where the prior is a discrete mixture of beta densities.
} 
\usage{
binomial.beta.mix(probs,betapar,data)
}
\arguments{
  \item{probs}{vector of probabilities of the beta components of the prior}
  \item{betapar}{matrix where each row contains the shape parameters for a beta component of the prior}
  \item{data}{vector of number of successes and number of failures}
}

\value{
\item{probs}{vector of  probabilities of the beta components of the posterior}
\item{betapar}{matrix where each row contains the shape parameters for a beta component of the posterior}
}
\author{Jim Albert}

\examples{
probs=c(.5, .5)
beta.par1=c(15,5)
beta.par2=c(10,10)
betapar=rbind(beta.par1,beta.par2)
data=c(20,15)
binomial.beta.mix(probs,betapar,data)
}

\keyword{models}

\name{careertraj.setup}
\alias{careertraj.setup}
\title{Setup for Career Trajectory Application}
\description{
 Setups the data matrices for the use of WinBUGS
 in the career trajectory application. 
}
\usage{
careertraj.setup(data)
}
\arguments{
 \item{data}{data matrix for ballplayers with variables Player, Year, Age, G, AB, R, H, X2B, X3B, HR, RBI, BB, SO}
}

\value{
\item{player.names}{vector of player names}
\item{y}{matrix of home runs for players where a row corresponds to the home runs for a player during
all the years of his career}
\item{n}{matrix of AB-SO for all players}
\item{x}{matrix of ages for all players for all years of their careers}
\item{T}{vector of number of seasons for all players}
\item{N}{number of players}
}

\author{Jim Albert}

\examples{
data(sluggerdata)
careertraj.setup(sluggerdata)
}

\keyword{models}

\name{breastcancer}
\alias{breastcancer}
\docType{data}
\title{Survival experience of women with breast cancer under treatment}
\description{
Collett (1994) describes a study to evaluate the effectiveness of a
histochemical marker in predicting the survival experience of women with
breast cancer.
}
\usage{
breastcancer
}
\format{
  A data frame with 45 observations on the following 3 variables.
  \describe{
  \item{time}{survival time in months}
  \item{status}{censoring indicator where 1 (0) indicates a complete (censored) survival time}
  \item{stain}{indicates by a 0 (1) if tumor was negatively (positively) stained}
  }
}
\source{Collett, D. (1994), Modelling Survival Data in Medical Research, London:
Chapman and Hall.}

\keyword{datasets}

\name{dmnorm}
\alias{dmnorm}
\title{The probability density function for the multivariate normal (Gaussian) probability distribution }
\description{
 Computes the density of a multivariate normal distribution
}
\usage{
dmnorm(x, mean = rep(0, d), varcov, log = FALSE)
}
\arguments{
  \item{x}{vector of length d or matrix with d columns, giving the coordinates of points where density is to evaluated}
  \item{mean}{numeric vector giving the location parameter of the distribution}
  \item{varcov}{a positive definite matrix representing the scale matrix of the distribution}
  \item{log}{a logical value; if TRUE, the logarithm of the density is to be computed}
}
\value{
vector of density values
}

\author{Jim Albert}

\examples{
mu <- c(1,12,2)
Sigma <- matrix(c(1,2,0,2,5,0.5,0,0.5,3), 3, 3)
x <- c(2,14,0)
f <- dmnorm(x, mu, Sigma)
}

\keyword{models}

\name{baseball.1964}
\alias{baseball.1964}
\docType{data}
\title{Team records in the 1964 National League baseball season}
\description{
Head to head records for all teams in the 1964 National League baseball
season.  Teams are coded as Cincinnati (1), Chicago (2), Houston (3),
Los Angeles (4), Milwaukee (5), New York (6), Philadelphia (7),
Pittsburgh (8), San Francisco (9), and St. Louis (10).
}
\usage{
baseball.1964
}
\format{
   A data frame with 45 observations on the following 4 variables.
  \describe{
  \item{Team.1}{Number of team 1}
  \item{Team.2}{Number of team 2}
  \item{Wins.Team1}{Number of games won by team 1}
  \item{Wins.Team2}{Number of games won by team 2}
  }
}
\source{
www.baseball-reference.com website.
}

\keyword{datasets}

\name{logpoissnormal}
\alias{logpoissnormal}
\title{Log  posterior with Poisson sampling and normal prior}
\description{
Computes the logarithm of the posterior density of a Poisson log mean
with a normal prior
}
\usage{
logpoissnormal(theta,datapar)
}
\arguments{
  \item{theta}{vector of values of the log mean parameter}
  \item{datapar}{list with components data, vector of observations, and par, vector of
parameters of the normal prior}
}

\value{
vector of values of the log posterior for all values in theta
}

\author{Jim Albert}

\examples{
data=c(2,4,3,6,1,0,4,3,10,2)
par=c(0,1)
datapar=list(data=data,par=par)
theta=c(-1,0,1,2)
logpoissnormal(theta,datapar)
}

\keyword{models}

\name{rdirichlet}
\alias{rdirichlet}
\title{Random draws from a Dirichlet distribution}
\description{
Simulates a sample from a Dirichlet distribution
}
\usage{
rdirichlet(n,par)
}
\arguments{
  \item{n}{number of simulations required}
  \item{par}{vector of parameters of the Dirichlet distribution}
}

\value{
matrix of simulated draws where each row corresponds to a single draw
}

\author{Jim Albert}

\examples{
par=c(2,5,4,10)
n=10
rdirichlet(n,par)
}

\keyword{models}

\name{pdiscp}
\alias{pdiscp}
\title{Predictive distribution for a binomial sample with a discrete prior}
\description{
 Computes predictive distribution for number of successes of
 future binomial experiment
 with a discrete distribution for the proportion.
}
\usage{
pdiscp(p, probs, n, s)
}
\arguments{
  \item{p}{vector of proportion values}
  \item{probs}{vector of probabilities}
  \item{n}{size of future binomial sample}
  \item{s}{vector of number of successes for future binomial experiment}
}

\value{
  vector of predictive probabilities for the values in the vector s
}

\author{Jim Albert}

\examples{
p=c(.1,.2,.3,.4,.5,.6,.7,.8,.9)
prob=c(0.05,0.10,0.10,0.15,0.20,0.15,0.10,0.10,0.05)
n=10
s=0:10
pdiscp(p,prob,n,s)
}

\keyword{models}

\name{simcontour}
\alias{simcontour}
\title{Simulated draws from a bivariate density function on a grid}
\description{
 For a general two parameter density defined on a grid, simulates a random sample.
}
\usage{
simcontour(logf,limits,data,m)
}
\arguments{
  \item{logf}{function that defines the logarithm of the  density}
  \item{limits}{limits (xlo, xhi, ylo, yhi) that cover the joint probability density}
  \item{data}{vector or list of parameters associated with the function logpost}
  \item{m}{size of simulated sample}
}

\value{
\item{x}{vector of simulated draws of the first parameter}
\item{y}{vector of simulated draws of the second parameter}
}

\author{Jim Albert}

\examples{
m=array(c(0,0),c(2,1))
v=array(c(1,.6,.6,1),c(2,2))
normpar=list(m=m,v=v)
s=simcontour(lbinorm,c(-4,4,-4,4),normpar,1000)
plot(s$x,s$y)
}

\keyword{models}

\name{schmidt}
\alias{schmidt}
\docType{data}
\title{Batting data for Mike Schmidt}
\description{
Batting statistics for the baseball player Mike Schmidt
during all the seasons of his career.
}
\usage{
schmidt
}
\format{
  A data frame with 18 observations on the following 14 variables.
  \describe{
  \item{Year}{year of the season}
  \item{Age}{Schmidt's age that season}
  \item{G}{games played}
  \item{AB}{at-bats}
  \item{R}{runs scored}
  \item{H}{number of hits}
  \item{X2B}{number of doubles}
  \item{X3B}{number of triples}
  \item{HR}{number of home runs}
  \item{RBI}{number of runs batted in}
  \item{SB}{number of stolen bases}
  \item{CS}{number of times caught stealing}
  \item{BB}{number of walks}
  \item{SO}{number of strikeouts}
  }
}
\source{Sean Lahman's baseball database from www.baseball1.com.}
\keyword{datasets}

\name{ordergibbs}
\alias{ordergibbs}
\title{Gibbs sampling for a hierarchical regression model}
\description{
 Implements Gibbs sampling for estimating a two-way table of means
under a order restriction.
}
\usage{
ordergibbs(data,m)
}
\arguments{
  \item{data}{data matrix with first two columns observed sample means and sample sizes}
  \item{m}{number of cycles of Gibbs sampling}
}

\value{
  matrix of simulated draws of the normal means where each row represents one simulated draw
}

\author{Jim Albert}

\examples{
data(iowagpa)
m=1000
s=ordergibbs(iowagpa,m)
}

\keyword{models}

\name{bprobit.probs}
\alias{bprobit.probs}
\title{Simulates fitted probabilities for a probit regression model}
\description{
 Gives a simulated sample for fitted probabilities for a binary response
regression model with a probit link and noninformative prior.
}
\usage{
bprobit.probs(X1,fit)
}
\arguments{
  \item{X1}{matrix where each row corresponds to a covariate set}
  \item{fit}{simulated matrix of draws of the regression vector}
}

\value{
matrix of simulated draws of the fitted probabilities, where a column corresponds to a
particular covariate set
}
\author{Jim Albert}

\examples{
response=c(0,1,0,0,0,1,1,1,1,1)
covariate=c(1,2,3,4,5,6,7,8,9,10)
X=cbind(1,covariate)
m=1000
fit=bayes.probit(response,X,m)
x1=c(1,3)
x2=c(1,8)
X1=rbind(x1,x2)
fittedprobs=bprobit.probs(X1,fit$beta)
}

\keyword{models}

\name{indepmetrop}
\alias{indepmetrop}
\title{Independence Metropolis independence chain of a posterior distribution}
\description{
 Simulates iterates of an independence Metropolis chain with a normal proposal density for an arbitrary real-valued
posterior density defined by the user}
\usage{
indepmetrop(logpost,proposal,start,m,...)
}
\arguments{
 \item{logpost}{function defining the log posterior density}
  \item{proposal}{a list containing mu, an estimated mean and var, an estimated variance-covariance matrix, of the normal proposal density} 
  \item{start}{vector containing the starting value of the parameter}
  \item{m}{the number of iterations of the chain}
  \item{...}{data that is used in the function logpost}
}
\value{
\item{par}{a matrix of simulated values where each row corresponds to a value of the vector parameter}
\item{accept}{the acceptance rate of the algorithm}
}
\author{Jim Albert}

\examples{
data=c(6,2,3,10)
proposal=list(mu=array(c(2.3,-.1),c(2,1)),var=diag(c(1,1)))
start=array(c(0,0),c(1,2))
m=1000
fit=indepmetrop(logctablepost,proposal,start,m,data)
}

\keyword{models}

\name{calculus.grades}
\alias{calculus.grades}
\docType{data}
\title{Calculus grades dataset}
\description{
Grades and other variables collected for a 
sample of calculus students.
}
\usage{
calculus.grades
}
\format{
   A data frame with 100 observations on the following 3 variables.
  \describe{
  \item{grade}{indicates if student received a A or B in class}
  \item{prev.grade}{indicates if student received a A in prerequisite math class}
  \item{act}{score on the ACT math test}
  }
}
\source{Collected by a colleague of the author at his university.}
\keyword{datasets}

\name{betabinexch0}
\alias{betabinexch0}
\title{Log posterior of mean and precision for Binomial/beta exchangeable model}
\description{
 Computes the log posterior density of mean and precision for a Binomial/beta exchangeable model
}
\usage{
betabinexch0(theta,data)
}
\arguments{
  \item{theta}{vector of parameter values of eta and K}
  \item{data}{a matrix with columns y (counts) and n (sample sizes)}
}

\value{
value of the log posterior}

\author{Jim Albert}

\examples{
n=c(20,20,20,20,20)
y=c(1,4,3,6,10)
data=cbind(y,n)
theta=c(.1,10)
betabinexch0(theta,data)
}

\keyword{models}

\name{weibullregpost}
\alias{weibullregpost}
\title{Log posterior of a Weibull proportional odds model for survival data}
\description{
 Computes the log posterior density of (log sigma, mu, beta) for a Weibull
proportional odds regression model
}
\usage{
weibullregpost(theta,data)
}
\arguments{
  \item{theta}{vector of parameter values log sigma, mu, and beta}
  \item{data}{data matrix with columns survival time, censoring variable, and covariate matrix}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
data(chemotherapy)
attach(chemotherapy)
d=cbind(time,status,treat-1,age)
theta=c(-.6,11,.6,0)
weibullregpost(theta,d)
}

\keyword{models}

\name{transplantpost}
\alias{transplantpost}
\title{Log posterior of a Pareto model for survival data}
\description{
 Computes the log posterior density of (log tau, log lambda, log p)  for a Pareto
model for survival data
}
\usage{
transplantpost(theta,data)
}
\arguments{
  \item{theta}{vector of parameter values of log tau, log lambda, and log p}
  \item{data}{data matrix with columns survival time, transplant indicator, time to transplant, and
censoring indicator}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
data(stanfordheart)
theta=c(0,3,-1)
transplantpost(theta,stanfordheart)
}

\keyword{models}

\name{bayesresiduals}
\alias{bayesresiduals}
\title{Computation of posterior residual outlying probabilities for a linear regression model}
\description{
 Computes the posterior probabilities that Bayesian residuals exceed a cutoff value for a 
linear regression model with a noninformative prior
}
\usage{
bayesresiduals(lmfit,post,k)
}
\arguments{
  \item{lmfit}{output of the regression function lm}
  \item{post}{list with components beta, matrix of simulated draws of regression parameter, and 
sigma, vector of simulated draws of sampling standard deviation}
  \item{k}{cut-off value that defines an outlier}
}

\value{
vector of posterior outlying probabilities
}
\author{Jim Albert}

\examples{
chirps=c(20,16.0,19.8,18.4,17.1,15.5,14.7,17.1,15.4,16.2,15,17.2,16,17,14.1)
temp=c(88.6,71.6,93.3,84.3,80.6,75.2,69.7,82,69.4,83.3,78.6,82.6,80.6,83.5,76.3)
X=cbind(1,chirps)
lmfit=lm(temp~X)
m=1000
post=blinreg(temp,X,m)
k=2
bayesresiduals(lmfit,post,k)
}

\keyword{models}

\name{predplot}
\alias{predplot}
\title{Plot of predictive distribution for binomial sampling with a beta prior}
\description{
For a proportion problem with a beta prior, plots the prior predictive distribution
of the number of successes in n trials and displays the observed number of successes.
}
\usage{
predplot(prior,n,yobs)
}
\arguments{
  \item{prior}{vector of parameters for beta prior}
  \item{n}{sample size}
  \item{yobs}{observed number of successes}
}

\author{Jim Albert}

\examples{
prior=c(3,10)  # proportion has a beta(3, 10) prior
n=20   # sample size
yobs=10  # observed number of successes
predplot(prior,n,yobs)
}

\keyword{models}

\name{normal.normal.mix}
\alias{normal.normal.mix}
\title{Computes the posterior for normal sampling and a mixture of normals prior}
\description{
 Computes the parameters and mixing probabilities for a normal sampling problem, variance known,
where the prior is a discrete mixture of normal densities.
} 
\usage{
normal.normal.mix(probs,normalpar,data)
}
\arguments{
  \item{probs}{vector of probabilities of the normal components of the prior}
  \item{normalpar}{matrix where each row contains the mean and variance parameters for a normal component of the prior}
  \item{data}{vector of observation and sampling variance}
}
\value{
\item{probs}{vector of  probabilities of the normal components of the posterior}
\item{normalpar}{matrix where each row contains the mean and variance parameters for a normal component of the posterior}
}
\author{Jim Albert}

\examples{
probs=c(.5, .5)
normal.par1=c(0,1)
normal.par2=c(2,.5)
normalpar=rbind(normal.par1,normal.par2)
y=1; sigma2=.5
data=c(y,sigma2)
normal.normal.mix(probs,normalpar,data)
}

\keyword{models}

\name{howardprior}
\alias{howardprior}
\title{Logarithm of Howard's dependent prior for two proportions}
\description{
Computes the logarithm of a dependent prior on two proportions
proposed by Howard in a Statistical Science paper in 1998.
}
\usage{
howardprior(xy,par)
}
\arguments{
  \item{xy}{vector of proportions p1 and p2}
  \item{par}{vector containing parameter values alpha, beta, gamma, delta, sigma}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
param=c(1,1,1,1,2)
p=c(.1,.5)
howardprior(p,param)
}

\keyword{models}

\name{sir}
\alias{sir}
\title{Sampling importance resampling}
\description{
 Implements sampling importance resampling for a multivariate
t proposal density. 
}
\usage{
sir(logf,tpar,n,data)
}
\arguments{
 \item{logf}{function defining logarithm of density of interest}
 \item{tpar}{list of parameters of multivariate t proposal density including
the mean m, the scale matrix var, and the degrees of freedom df}
 \item{n}{number of simulated draws from the posterior}
  \item{data}{data and parameters used in the function logf}
}
\value{
matrix of simulated draws from the posterior where each row corresponds to a single draw
}
\author{Jim Albert}

\examples{
data(cancermortality)
start=c(-7,6)
fit=laplace(betabinexch,start,cancermortality)
tpar=list(m=fit$mode,var=2*fit$var,df=4)
theta=sir(betabinexch,tpar,1000,cancermortality)
}

\keyword{models}

\name{studentdata}
\alias{studentdata}
\docType{data}
\title{Student dataset}
\description{
Answers to a sheet of questions given to a large number
of students in introductory statistics classes
}
\usage{
studentdata
}
\format{
 A data frame with 657 observations on the following 11 variables.
  \describe{
  \item{Student}{student number}
  \item{Height}{height in inches}
  \item{Gender}{gender}
  \item{Shoes}{number of pairs of shoes owned}
  \item{Number}{number chosen between 1 and 10}
  \item{Dvds}{name of movie dvds owned}
  \item{ToSleep}{time the person went to sleep the previous night (hours past midnight)}
  \item{WakeUp}{time the person woke up the next morning}
  \item{Haircut}{cost of last haircut including tip}
  \item{Job}{number of hours working on a job per week}
  \item{Drink}{usual drink at suppertime among milk, water, and pop}
  }
}

\source{Collected by the author during the Fall 2006 semester.}
\keyword{datasets}

\name{puffin}
\alias{puffin}
\docType{data}
\title{Bird measurements from British islands}
\description{
Measurements on breedings of the common puffin on different
habits at Great Island, Newfoundland.
}
\usage{
puffin
}
\format{
 A data frame with 38 observations on the following 5 variables.
  \describe{
  \item{Nest}{nesting frequency (burrows per 9 square meters)}
  \item{Grass}{grass cover (percentage)}
  \item{Soil}{mean soil depth (in centimeters)}
  \item{Angle}{angle of slope (in degrees)}
  \item{Distance}{distance from cliff edge (in meters)}
  }
}
\source{Peck, R., Devore, J., and Olsen, C. (2005), Introduction to Statistics 
And Data Analysis, Thomson Learning.}
\keyword{datasets}

\name{bayes.influence}
\alias{bayes.influence}
\title{Observation sensitivity analysis in beta-binomial model}
\description{
 Computes probability intervals for the log precision parameter K
in a beta-binomial model for all "leave one out" models using sampling
importance resampling 
}
\usage{
bayes.influence(theta,data)
}
\arguments{
 \item{theta}{matrix of simulated draws from the posterior of (logit eta, log K)}
  \item{data}{matrix with columns of counts and sample sizes}
}
\value{
\item{summary}{vector of 5th, 50th, 95th percentiles of log K for complete sample posterior}
\item{summary.obs}{matrix where the ith row contains the 5th, 50th, 95th percentiles
of log K for posterior when the ith observation is removed}
}
\author{Jim Albert}

\examples{
data(cancermortality)
start=array(c(-7,6),c(1,2))
fit=laplace(betabinexch,start,cancermortality)
tpar=list(m=fit$mode,var=2*fit$var,df=4)
theta=sir(betabinexch,tpar,1000,cancermortality)
intervals=bayes.influence(theta,cancermortality)
}

\keyword{models}

\name{birthweight}
\alias{birthweight}
\docType{data}
\title{Birthweight regression study}
\description{
Dobson describes a study where one is interested in predicting 
a baby's birthweight based on the gestational age and the baby's
gender.
}
\usage{
birthweight
}
\format{
  A data frame with 24 observations on the following 3 variables.
  \describe{
  \item{age}{gestational age in weeks}
  \item{gender}{gender of the baby where 0 (1) is male (female)}
  \item{weight}{birthweight of baby in grams}
  }
}
\source{Dobson, A. (2001), An Introduction to Generalized Linear Models, New York:
Chapman and Hall.}

\keyword{datasets}

\name{normpostpred}
\alias{normpostpred}
\title{Posterior predictive simulation from Bayesian normal sampling model}
\description{
 Given simulated draws from the posterior from a normal sampling model, outputs
simulated draws from the posterior predictive distribution of a statistic of interest.
}
\usage{
normpostpred(parameters,sample.size,f=min)
}
\arguments{
  \item{parameters}{list of simulated draws from the posterior where mu contains the normal mean
and sigma2 contains the normal variance}
  \item{sample.size}{size of sample of future sample}
  \item{f}{function defining the statistic}
}

\value{
simulated sample of the posterior predictive distribution of the statistic}
\author{Jim Albert}

\examples{
# finds posterior predictive distribution of the min statistic of a future sample of size 15
data(darwin)
s=normpostsim(darwin$difference)
sample.size=15
sim.stats=normpostpred(s,sample.size,min)
}

\keyword{models}

\name{birdextinct}
\alias{birdextinct}
\docType{data}
\title{Bird measurements from British islands}
\description{
Measurements on breedings pairs of landbird species were collected from 16
islands about Britain over several decades.
}
\usage{
birdextinct
}
\format{
A data frame with 62 observations on the following 5 variables.
  \describe{
  \item{species}{name of bird species}
  \item{time}{average time of extinction on the islands}
  \item{nesting}{average number of nesting pairs}
  \item{size}{size of the species, 1 or 0 if large or small}
  \item{status}{staus of the species, 1 or 0 if resident or migrant}
  }
}
\source{
Pimm, S., Jones, H., and Diamond, J. (1988),
On the risk of extinction,
American Naturalists, 132, 757-785.
}

\keyword{datasets}

\name{laplace}
\alias{laplace}
\title{Summarization of a posterior density by the Laplace method}
\description{
 For a general posterior density, computes the posterior mode, 
the associated variance-covariance matrix, and an estimate at the
logarithm at the normalizing constant.
}
\usage{
laplace(logpost,mode,...)
}
\arguments{
  \item{logpost}{function that defines the logarithm of the posterior density}
  \item{mode}{vector that is a guess at the posterior mode}
  \item{...}{vector or list of parameters associated with the function logpost}
}

\value{
\item{mode}{current estimate at the posterior mode}
\item{var}{current estimate at the associated variance-covariance matrix}
\item{int}{estimate at the logarithm of the normalizing constant}
\item{converge}{indication (TRUE or FALSE) if the algorithm converged}
}

\author{Jim Albert}

\examples{
logpost=function(theta,data)
{
s=5
sum(-log(1+(data-theta)^2/s^2))
}
data=c(10,12,14,13,12,15)
start=10
laplace(logpost,start,data)
}

\keyword{models}

\name{bradley.terry.post}
\alias{bradley.terry.post}
\title{Log posterior of a Bradley Terry random effects model}
\description{
 Computes the log posterior density of the talent parameters and the log 
standard deviation for a Bradley Terry model with normal
random effects
}
\usage{
bradley.terry.post(theta,data)
}

\arguments{
  \item{theta}{vector of talent parameters and log standard deviation}
  \item{data}{data matrix with columns team1, team2, wins by team1, and
wins by team2}
}

\value{value of the log posterior}

\author{Jim Albert}

\examples{
data(baseball.1964)
team.strengths=rep(0,10)
log.sigma=0
bradley.terry.post(c(team.strengths,log.sigma),baseball.1964)
}

\keyword{models}

\name{poissgamexch}
\alias{poissgamexch}
\title{Log posterior of Poisson/gamma exchangeable model}
\description{
 Computes the log posterior density of log alpha and log mu for a Poisson/gamma exchangeable model
}
\usage{
poissgamexch(theta,datapar)
}
\arguments{
  \item{theta}{vector of parameter values of log alpha and log mu}
  \item{datapar}{list with components data, a matrix with columns e and y, and z0, prior hyperparameter}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
e=c(532,584,672,722,904)
y=c(0,0,2,1,1)
data=cbind(e,y)
theta=c(-4,0)
z0=.5
datapar=list(data=data,z0=z0)
poissgamexch(theta,datapar)
}

\keyword{models}

\name{darwin}
\alias{darwin}
\docType{data}
\title{Darwin's data on plants}
\description{
Fifteen differences of the heights of cross and self fertilized plants quoted by
Fisher (1960)}

\usage{
darwin
}
\format{
A data frame with 15 observations on the following 1 variable.
  \describe{
  \item{difference}{difference of heights of two types of plants}
  }
}
\source{Fisher, R. (1960), Statistical Methods for Research Workers,
Edinburgh: Oliver and Boyd.}
\keyword{datasets}

\name{stanfordheart}
\alias{stanfordheart}
\docType{data}
\title{Data from Stanford Heart Transplanation Program}
\description{
Heart transplant data for 82 patients from Stanford Heart Transplanation Program}

\usage{
stanfordheart
}
\format{
A data frame with 82 observations on the following 4 variables.
  \describe{
  \item{survtime}{survival time in months}
  \item{transplant}{variable that is 1 or 0 if patient had transplant or not}
  \item{timetotransplant}{time a transplant patient waits for operation}
  \item{state}{variable that is 1 or 0 if time is censored or not}
  }
}
\source{Turnbull, B., Brown, B. and Hu, M. (1974), Survivorship 
analysis of heart transplant data, Journal of the 
 American Statistical Association, 69, 74-80.}
\keyword{datasets}

\name{strikeout}
\alias{strikeout}
\docType{data}
\title{Baseball strikeout data}
\description{
For all professional baseball players in the 2004 season, dataset gives the
number of strikeouts and at-bats when runners are in scoring position and when
runners are not in scoring position.
}
\usage{
strikeout
}
\format{
  A data frame with 438 observations on the following 4 variables.
  \describe{
  \item{r}{number of strikeouts of player when runners are not in scoring position}
  \item{n}{number of at-bats of player when runners are not in scoring position}
  \item{s}{number of strikeouts of player when runners are in scoring position}
  \item{m}{number of at-bats of player when runners are in scoring position}
  }
}
\source{Collected from www.espn.com website.}
\keyword{datasets}

\name{bermuda.grass}
\alias{bermuda.grass}
\docType{data}
\title{Bermuda grass experiment data}
\description{
Yields of bermuda grass for a factorial design of nutrients
nitrogen,
phosphorus, and potassium.
}
\usage{
bermuda.grass
}
\format{
   A data frame with 64 observations on the following 4 variables.
  \describe{
  \item{y}{yield of bermuda grass in tons per acre}
  \item{Nit}{level of nitrogen}
  \item{Phos}{level of phosphorus}
  \item{Pot}{level of potassium}
  }
}
\source{
McCullagh, P., and Nelder, J. (1989), Generalized Linear Models,
Chapman and Hall.
}
\keyword{datasets}

\name{robustt}
\alias{robustt}
\title{Gibbs sampling for a robust regression model}
\description{
 Implements Gibbs sampling for a robust t sampling model with location mu, scale sigma, and degrees of freedom v }
\usage{
robustt(y,v,m)
}
\arguments{
 \item{y}{vector of data values}
  \item{v}{degrees of freedom for t model} 
  \item{m}{the number of cycles of the Gibbs sampler}
}
\value{
\item{mu}{vector of simulated values of mu}
\item{s2}{vector of simulated values of sigma2}
\item{lam}{matrix of simulated draws of lambda, where each row corresponds to a single draw}
}
\author{Jim Albert}

\examples{
data=c(-67,-48,6,8,14,16,23,24,28,29,41,49,67,60,75)
fit=robustt(data,4,1000)
}

\keyword{models}

\name{pbetat}
\alias{pbetat}
\title{Bayesian test of a proportion}
\description{
 Bayesian test that a proportion is equal to a specified
 value using a beta prior}
\usage{
pbetat(p0,prob,ab,data)
}
\arguments{
  \item{p0}{value of the proportion to be tested }
  \item{prob}{prior probability of the hypothesis}
  \item{ab}{vector of parameter values of the beta prior under the alternative hypothesis}
  \item{data}{vector containing the number of successes and number of failures}
}

\value{
  \item{bf}{the Bayes factor
  in support of the null hypothesis}
  \item{post}{the posterior probability
  of the null hypothesis}
}

\author{Jim Albert}

\examples{
p0=.5
prob=.5
ab=c(10,10)
data=c(5,15)
pbetat(p0,prob,ab,data)
}

\keyword{models}

\name{iowagpa}
\alias{iowagpa}
\docType{data}
\title{Admissions data for an university}
\description{
Students at a major university are categorized with respect to their
high school rank and their ACT score.  For each combination of high school rank and
ACT score, one records the mean grade point average (GPA).
}
\usage{
iowagpa
}
\format{
 A data frame with 40 observations on the following 4 variables.
  \describe{
  \item{gpa}{mean grade point average}
  \item{n}{sample size}
  \item{HSR}{high school rank}
  \item{ACT}{act score}
  }
}
\source{Albert, J. (1994), A Bayesian approach to estimation of GPA's
of University of Iowa freshmen under order restrictions,
Journal of Educational Statistics, 19, 1-22.}
\keyword{datasets}

\name{impsampling}
\alias{impsampling}
\title{Importance sampling using a t proposal density}
\description{
 Implements importance sampling to compute the posterior mean of a function
using a multivariate t proposal density 
}
\usage{
impsampling(logf,tpar,h,n,data)
}
\arguments{
 \item{logf}{function that defines the logarithm of the density of interest}
  \item{tpar}{list of parameters of t proposal density including the mean m, scale matrix var, 
and degrees of freedom df} 
  \item{h}{function that defines h(theta)}
  \item{n}{number of simulated draws from proposal density}
  \item{data}{data and or parameters used in the function logf}
}
\value{
\item{est}{estimate at the posterior mean}
\item{se}{simulation standard error of estimate}
\item{theta}{matrix of simulated draws from proposal density}
\item{wt}{vector of importance sampling weights}
}
\author{Jim Albert}

\examples{
data(cancermortality)
start=c(-7,6)
fit=laplace(betabinexch,start,cancermortality)
tpar=list(m=fit$mode,var=2*fit$var,df=4)
myfunc=function(theta) return(theta[2])
theta=impsampling(betabinexch,tpar,myfunc,1000,cancermortality)
}

\keyword{models}

\name{normpostsim}
\alias{normpostsim}
\title{Simulation from Bayesian normal sampling model}
\description{
 Gives a simulated sample from the joint posterior distribution of the mean and
variance for a normal sampling prior with a noninformative or
informative prior.  The prior assumes mu and sigma2 are independent with
mu assigned a normal prior with mean mu0 and variance tau2, and sigma2 is
assigned a inverse gamma prior with parameters a and b.
}
\usage{
normpostsim(data,prior=NULL,m=1000)
}
\arguments{
  \item{data}{vector of observations}
  \item{prior}{list with components mu, a vector with the prior mean 
  and variance, and sigma2, a vector of the inverse gamma parameters}
  \item{m}{number of simulations desired}
}

\value{
\item{mu}{vector of simulated draws of normal mean}
\item{sigma2}{vector of simulated draws of normal variance}
}
\author{Jim Albert}

\examples{
data(darwin)
s=normpostsim(darwin$difference)
}

\keyword{models}

\name{blinreg}
\alias{blinreg}
\title{Simulation from Bayesian linear regression model}
\description{
 Gives a simulated sample from the joint posterior distribution of the regression
vector and the error standard deviation for a linear regression model with a 
 noninformative or g prior.
}
\usage{
blinreg(y,X,m,prior=NULL)
}
\arguments{
  \item{y}{vector of responses}
  \item{X}{design matrix}
  \item{m}{number of simulations desired}
  \item{prior}{list with components c0 and beta0 of Zellner's g prior}
}

\value{
\item{beta}{matrix of simulated draws of beta where each row corresponds to one draw}
\item{sigma}{vector of simulated draws of the error standard deviation}
}
\author{Jim Albert}

\examples{
chirps=c(20,16.0,19.8,18.4,17.1,15.5,14.7,17.1,15.4,16.2,15,17.2,16,17,14.1)
temp=c(88.6,71.6,93.3,84.3,80.6,75.2,69.7,82,69.4,83.3,78.6,82.6,80.6,83.5,76.3)
X=cbind(1,chirps)
m=1000
s=blinreg(temp,X,m)
}

\keyword{models}

\name{histprior}
\alias{histprior}
\title{Density function of a histogram distribution}
\description{
Computes the density of a probability distribution defined on a set
of equal-width intervals
}
\usage{
histprior(p,midpts,prob)
}
\arguments{
  \item{p}{vector of values for which density is to be computed}
  \item{midpts}{vector of midpoints of the intervals}
  \item{prob}{vector of probabilities of the intervals}
}

\value{
vector of values of the probability density
}

\author{Jim Albert}

\examples{
midpts=c(.1,.3,.5,.7,.9)
prob=c(.2,.2,.4,.1,.1)
p=seq(.01,.99,by=.01)
plot(p,histprior(p,midpts,prob),type="l")
}

\keyword{models}

\name{bfexch}
\alias{bfexch}
\title{Logarithm of integral of Bayes factor for testing homogeneity of proportions}
\description{
Computes the logarithm of the integral of the Bayes factor for testing homogeneity of a set of proportions
}
\usage{
bfexch(theta,datapar)
}
\arguments{
  \item{theta}{value of the logit of the prior mean hyperparameter}
  \item{datapar}{list with components data, matrix with columns y (counts) and n (sample sizes), and K, prior
precision hyperparameter}
}

\value{
value of the logarithm of the integral
}

\author{Jim Albert}

\examples{
y=c(1,3,2,4,6,4,3)
n=c(10,10,10,10,10,10,10)
data=cbind(y,n)
K=20
datapar=list(data=data,K=K)
theta=1
bfexch(theta,datapar)
}

\keyword{models}

\name{chemotherapy}
\alias{chemotherapy}
\docType{data}
\title{Chemotherapy treatment effects on ovarian cancer}
\description{
Edmunson et al (1979) studied the effect of different chemotherapy
treatments following surgical treatment of ovarian cancer.
}
\usage{
chemotherapy
}
\format{
  A data frame with 26 observations on the following 5 variables.
  \describe{
  \item{patient}{patient number}
  \item{time}{survival time in days following treatment}
  \item{status}{indicates if time is censored (0) or actually observed (1)}
  \item{treat}{control group (0) or treatment group (1)}
  \item{age}{age of the patient}
  }
}
\source{Edmonson, J., Felming, T., Decker, D., Malkasian, G., Jorgensen, E.,
Jefferies,
J.,Webb, M., and Kvols, L. (1979), Different chemotherapeutic sensitivities
and host factors affecting prognosis in advanced ovarian carcinoma versus
minimal residual disease, Cancer Treatment Reports, 63, 241-247.
}

\keyword{datasets}

\name{bfindep}
\alias{bfindep}
\title{Bayes factor against independence assuming alternatives close to independence}
\description{
Computes a Bayes factor against independence for a two-way contingency table assuming
a "close to independence" alternative model}
\usage{
bfindep(y,K,m)
}
\arguments{
  \item{y}{matrix of counts}
  \item{K}{Dirichlet precision hyperparameter}
  \item{m}{number of simulations}
}

\value{
\item{bf}{value of the Bayes factor against hypothesis of independence}
\item{nse}{estimate of the simulation standard error of the computed Bayes factor}
}

\author{Jim Albert}

\examples{
y=matrix(c(10,4,6,3,6,10),c(2,3))
K=20
m=1000
bfindep(y,K,m)
}

\keyword{models}

\name{rigamma}
\alias{rigamma}
\title{Random number generation for inverse gamma distribution}
\description{
 Simulates from a inverse gamma (a, b) distribution with density 
proportional to $y^(-a-1) exp(-b/y)$
}
\usage{
rigamma(n, a, b)
}
\arguments{
  \item{n}{number of random numbers to be generated}
  \item{a}{inverse gamma shape parameter}
  \item{b}{inverse gamma rate parameter}
}
\value{
vector of n simulated draws
}

\author{Jim Albert}

\examples{
a=10
b=5
n=20
rigamma(n,a,b)
}

\keyword{models}

\name{rtruncated}
\alias{rtruncated}
\title{Simulates from a truncated probability distribution}
\description{
 Simulates a sample from a truncated distribution where the functions for the cdf and inverse cdf are available.
} 
\usage{
rtruncated(n,lo,hi,pf,qf,...)
}
\arguments{
  \item{n}{size of simulated sample}
  \item{lo}{low truncation point}
  \item{hi}{high truncation point}
  \item{pf}{function containing cdf of untruncated distribution}
  \item{qf}{function containing inverse cdf of untruncated distribution}
  \item{...}{parameters used in the functions pf and qf}
}

\value{
vector of simulated draws from distribution}

\author{Jim Albert}

\examples{
# want a sample of 10 from normal(2, 1) distribution truncated below by 3
n=10
lo=3
hi=Inf
rtruncated(n,lo,hi,pnorm,qnorm,mean=2,sd=1)
# want a sample of 20 from beta(2, 5) distribution truncated to (.3, .8)
n=20
lo=0.3
hi=0.8
rtruncated(n,lo,hi,pbeta,qbeta,2,5)
}
\keyword{models}

\name{discrete.bayes.2}
\alias{discrete.bayes.2}
\alias{plot.bayes2}
\title{Posterior distribution of two parameters with discrete priors}
\description{
Computes the posterior distribution for an arbitrary two parameter distribution
 for a discrete prior
distribution.
}
\usage{
discrete.bayes.2(df,prior,y=NULL,...)
}
\arguments{
  \item{df}{name of the function defining the sampling density of
two parameters}
  \item{prior}{matrix defining the prior density; the row names and column names
of the matrix define respectively the values of parameter 1 and values of
parameter 2 and the entries of the matrix give the prior probabilities}
  \item{y}{y is a matrix of data values, where each row corresponds to a 
single observation}
  \item{...}{any further fixed parameter values 
used in the sampling density function}
}

\value{
  \item{prob}{matrix of posterior probabilities}
  \item{pred}{scalar with prior predictive probability}
}

\author{Jim Albert}

\examples{
p1 = seq(0.1, 0.9, length = 9)
p2 = p1
prior = matrix(1/81, 9, 9)
dimnames(prior)[[1]] = p1
dimnames(prior)[[2]] = p2
discrete.bayes.2(twoproplike,prior)
}

\keyword{models}

\name{discrete.bayes}
\alias{discrete.bayes}
\alias{print.bayes}
\alias{plot.bayes}
\alias{summary.bayes}
\title{Posterior distribution with discrete priors}
\description{
Computes the posterior distribution for an arbitrary one parameter distribution
 for a discrete prior
distribution.
}
\usage{
discrete.bayes(df,prior,y,...)
}
\arguments{
  \item{df}{name of the function defining the sampling density}
  \item{prior}{vector defining the prior density; names of the vector
  define the parameter values and entries of the vector define 
  the prior probabilities}
  \item{y}{vector of data values}
  \item{...}{any further fixed parameter values used in the sampling density
  function}
}
\value{
  \item{prob}{vector of posterior probabilities}
  \item{pred}{scalar with prior predictive probability}
}

\author{Jim Albert}

\examples{
prior=c(.25,.25,.25,.25)
names(prior)=c(.2,.25,.3,.35)
y=5
n=10
discrete.bayes(dbinom,prior,y,size=n)
}

\keyword{models}

\name{normchi2post}
\alias{normchi2post}
\title{Log posterior density for mean and variance for normal sampling}
\description{
 Computes the log of the posterior density of a mean M and a variance S2 when a sample is taken from a normal density and a standard noninformative prior is used.
}
\usage{
normchi2post(theta,data)
}
\arguments{
  \item{theta}{vector of parameter values M and S2}
  \item{data}{vector containing the sample observations}
}
\value{
value of the log posterior
}
\author{Jim Albert}

\examples{
parameter=c(25,5)
data=c(20, 32, 21, 43, 33, 21, 32)
normchi2post(parameter,data)
}

\keyword{models}

\name{reg.gprior.post}
\alias{reg.gprior.post}
\title{Computes the log posterior of a normal regression model with a g prior.}
\description{
 Computes the log posterior of (beta, log sigma) for a normal regression
model with a g prior with parameters beta0 and c0.
} 
\usage{
reg.gprior.post(theta, dataprior)
}
\arguments{
  \item{theta}{vector of components of beta and log sigma}
  \item{dataprior}{list with components data and prior; data is a list
with components y and X, prior is a list with components b0 and c0}
}
\value{
 value of the log posterior
}
\author{Jim Albert}

\examples{
data(puffin)
data=list(y=puffin$Nest, X=cbind(1,puffin$Distance))
prior=list(b0=c(0,0), c0=10)
reg.gprior.post(c(20,-.5,1),list(data=data,prior=prior))
}

\keyword{models}

\name{logctablepost}
\alias{logctablepost}
\title{Log posterior of difference and sum of logits in a 2x2 table}
\description{
 Computes the log posterior density for the difference and sum of logits
in a 2x2 contingency table for independent binomial samples and uniform
prior placed on the logits
}
\usage{
logctablepost(theta,data)
}
\arguments{
  \item{theta}{vector of parameter values "difference of logits" and "sum of logits")}
  \item{data}{vector containing number of successes and failures for first sample, and then second sample}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
s1=6; f1=2; s2=3; f2=10
data=c(s1,f1,s2,f2)
theta=c(2,4)
logctablepost(theta,data)
}

\keyword{models}

\name{ctable}
\alias{ctable}
\title{Bayes factor against independence using uniform priors}
\description{
Computes a Bayes factor against independence for a two-way contingency table assuming
uniform prior distributions}
\usage{
ctable(y,a)
}
\arguments{
  \item{y}{matrix of counts}
  \item{a}{matrix of prior hyperparameters}
}

\value{
value of the Bayes factor against independence
}

\author{Jim Albert}

\examples{
y=matrix(c(10,4,6,3,6,10),c(2,3))
a=matrix(rep(1,6),c(2,3))
ctable(y,a)
}

\keyword{models}

\name{jeter2004}
\alias{jeter2004}
\docType{data}
\title{Hitting data for Derek Jeter}
\description{
Batting data for the baseball player Derek Jeter for all 154 games in the 2004 season.}

\usage{
jeter2004
}
\format{
  A data frame with 154 observations on the following 10 variables.
  \describe{
  \item{Game}{the game number}
  \item{AB}{the number of at-bats}
  \item{R}{the number of runs scored}
  \item{H}{the number of hits}
  \item{X2B}{the number of doubles}
  \item{X3B}{the number of triples}
  \item{HR}{the number of home runs}
  \item{RBI}{the number of runs batted in}
  \item{BB}{the number of walks}
  \item{SO}{the number of strikeouts}
  }
}
\source{Collected from game log data from www.retrosheet.org.}
\keyword{datasets}

\name{rejectsampling}
\alias{rejectsampling}
\title{Rejecting sampling using a t proposal density}
\description{
 Implements a rejection sampling algorithm for a probability density
using a multivariate t proposal density 
}
\usage{
rejectsampling(logf,tpar,dmax,n,data)
}
\arguments{
 \item{logf}{function that defines the logarithm of the density of interest}
  \item{tpar}{list of parameters of t proposal density including the mean m, scale matrix var, 
and degrees of freedom df} 
  \item{dmax}{logarithm of the rejection sampling constant}
  \item{n}{number of simulated draws from proposal density}
  \item{data}{data and or parameters used in the function logf}
}
\value{
matrix of simulated draws from density of interest
}
\author{Jim Albert}

\examples{
data(cancermortality)
start=c(-7,6)
fit=laplace(betabinexch,start,cancermortality)
tpar=list(m=fit$mode,var=2*fit$var,df=4)
theta=rejectsampling(betabinexch,tpar,-569.2813,1000,cancermortality)
}

\keyword{models}

\name{groupeddatapost}
\alias{groupeddatapost}
\title{Log posterior of normal parameters when data is in grouped form}
\description{
 Computes the log posterior density of (M,log S) for normal sampling where the data is
observed in grouped form
}
\usage{
groupeddatapost(theta,data)
}
\arguments{
  \item{theta}{vector of parameter values M and log S}
  \item{data}{list with components int.lo, a vector of left endpoints,
int.hi, a vector of right endpoints, and f, a vector of bin frequencies}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
int.lo=c(-Inf,10,15,20,25)
int.hi=c(10,15,20,25,Inf)
f=c(2,5,8,4,2)
data=list(int.lo=int.lo,int.hi=int.hi,f=f)
theta=c(20,1)
groupeddatapost(theta,data)
}

\keyword{models}

\name{bayes.probit}
\alias{bayes.probit}
\title{Simulates from a probit binary response regression model using data augmentation and Gibbs sampling}
\description{
 Gives a simulated sample from the joint posterior distribution of the regression
vector for a binary response regression model with a probit link and a 
informative normal(beta, P) prior.  Also computes the log marginal likelihood when
a subjective prior is used.
}
\usage{
bayes.probit(y,X,m,prior=list(beta=0,P=0))
}
\arguments{
  \item{y}{vector of binary responses}
  \item{X}{covariate matrix}
  \item{m}{number of simulations desired}
  \item{prior}{list with components beta, the prior mean, and P, the prior precision matrix}
}

\value{
\item{beta}{matrix of simulated draws of regression vector beta where each row corresponds to one draw}
\item{log.marg}{simulation estimate at log marginal likelihood of the model}
}
\author{Jim Albert}

\examples{
response=c(0,1,0,0,0,1,1,1,1,1)
covariate=c(1,2,3,4,5,6,7,8,9,10)
X=cbind(1,covariate)
prior=list(beta=c(0,0),P=diag(c(.5,10)))
m=1000
s=bayes.probit(response,X,m,prior)
}

\keyword{models}

\name{achievement}
\alias{achievement}
\docType{data}
\title{School achievement data}
\description{
Achievement data for a group of Austrian school children
}
\usage{
achievement
}
\format{
  A data frame with 109 observations on the following 7 variables.
  \describe{
  \item{Gen}{gender of child where 0 is male and 1 is female}
  \item{Age}{age in months}
  \item{IQ}{iq score}
  \item{math1}{test score on mathematics computation}
  \item{math2}{test score on mathematics problem solving}
  \item{read1}{test score on reading speed}
  \item{read2}{test score on reading comprehension}
  }
}
\source{
Abraham, B., and Ledolter, J. (2006), Introduction to Regression Modeling, 
Duxbury.
}

\keyword{datasets}

\name{logisticpost}
\alias{logisticpost}
\title{Log posterior for a binary response model with a logistic link and a uniform prior}
\description{
 Computes the log posterior density of (beta0, beta1)  when
yi are independent binomial(ni, pi) and logit(pi)=beta0+beta1*xi and
a uniform prior is placed on (beta0, beta1)
}
\usage{
logisticpost(beta,data)
}
\arguments{
  \item{beta}{vector of parameter values beta0 and beta1}
  \item{data}{matrix of columns of covariate values x, sample sizes n, and number of successes y}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
x = c(-0.86,-0.3,-0.05,0.73)
n = c(5,5,5,5)
y = c(0,1,3,5)
data = cbind(x, n, y)
beta=c(2,10)
logisticpost(beta,data)
}

\keyword{models}

\name{sluggerdata}
\alias{sluggerdata}
\docType{data}
\title{Hitting statistics for ten great baseball players}
\description{
Career hitting statistics for ten great baseball players
}

\usage{
sluggerdata
}
\format{
 A data frame with 199 observations on the following 13 variables.
  \describe{
  \item{Player}{names of the ballplayer}
  \item{Year}{season played}
  \item{Age}{age of the player during the season}
  \item{G}{games played}
  \item{AB}{number of at-bats}
  \item{R}{number of runs scored}
  \item{H}{number of hits}
  \item{X2B}{number of doubles}
  \item{X3B}{number of triples}
  \item{HR}{number of home runs}
  \item{RBI}{runs batted in}
  \item{BB}{number of base on balls}
  \item{SO}{number of strikeouts}
  }
}
\source{Sean Lahman's baseball database from www.baseball1.com.}
\keyword{datasets}

\name{regroup}
\alias{regroup}
\title{Collapses a matrix by summing over rows}
\description{
Collapses a matrix by summing over a specific number of rows 
}
\usage{
regroup(data,g)
}
\arguments{
  \item{data}{a matrix}
  \item{g}{a positive integer beween 1 and the number of rows of data}
}

\value{
 reduced matrix found by summing over rows
}
\author{Jim Albert}

\examples{
data=matrix(c(1:20),nrow=4,ncol=5)
g=2
regroup(data,2)
}
\keyword{models}

\name{donner}
\alias{donner}
\docType{data}
\title{Donner survival study}
\description{
Data contains the age, gender and survival status for 45 members of the Donner Party
who experienced difficulties in crossing the Sierra Nevada mountains in California.
}
\usage{
donner
}
\format{
A data frame with 45 observations on the following 3 variables.
  \describe{
  \item{age}{age of person}
  \item{male}{gender that is 1 (0) if person is male (female)}
  \item{survival}{survival status, 1 or 0 if person survived or died}
  }
}
\source{Grayson, D. (1960), Donner party deaths:  a demographic
assessment, Journal of Anthropological Assessment, 46, 223-242.}

\keyword{datasets}

\name{bayes.model.selection}
\alias{bayes.model.selection}
\title{Bayesian regression model selection using G priors}
\description{
Using Zellner's G priors, computes the log marginal density for all possible regression models
}
\usage{
bayes.model.selection(y, X, c, constant=TRUE)
}
\arguments{
  \item{y}{vector of response values}
  \item{X}{matrix of covariates}
  \item{c}{parameter of the G prior}
  \item{constant}{logical variable indicating if a constant term is in the matrix X}
}

\value{
\item{mod.prob}{data frame specifying the model, the value of the log marginal density and
the value of the posterior model probability}
\item{converge}{logical vector indicating if the laplace algorithm converged for each model}
}

\author{Jim Albert}

\examples{
data(birdextinct)
logtime=log(birdextinct$time)
X=cbind(1,birdextinct$nesting,birdextinct$size,birdextinct$status)
bayes.model.selection(logtime,X,100)
}

\keyword{models}

\name{election}
\alias{election}
\docType{data}
\title{Florida election data}
\description{
For each of the Florida counties in the 2000 presidential election, the number of
votes for George Bush, Al Gore, and Pat Buchanan is recorded.  Also the number of
votes for the minority candidate Ross Perot in the 1996 presidential election is
recorded.
}
\usage{
election
}
\format{
  A data frame with 67 observations on the following 5 variables.
  \describe{
  \item{county}{name of Florida county}
  \item{perot}{number of votes for Ross Perot in 1996 election}
  \item{gore}{number of votes for Al Gore in 2000 election}
  \item{bush}{number of votes for George Bush in 2000 election}
  \item{buchanan}{number of votes for Pat Buchanan in 2000 election}
  }
}
\keyword{datasets}

\name{cauchyerrorpost}
\alias{cauchyerrorpost}
\title{Log posterior of median and log scale parameters for Cauchy sampling}
\description{
 Computes the log posterior density of (M,log S)  when
a sample is taken from a Cauchy density with location M and scale S and a uniform
prior distribution is taken on (M, log S)
}
\usage{
cauchyerrorpost(theta,data)
}
\arguments{
  \item{theta}{vector of parameter values of M and log S}
  \item{data}{vector containing sample of observations}
}

\value{
value of the log posterior
}

\author{Jim Albert}

\examples{
data=c(108, 51, 7, 43, 52, 54, 53, 49, 21, 48)
theta=c(40,1)
cauchyerrorpost(theta,data)
}

\keyword{models}

\name{soccergoals}
\alias{soccergoals}
\docType{data}
\title{Goals scored by professional soccer team}
\description{
Number of goals scored by a single professional soccer team
during the 2006 Major League Soccer season}

\usage{
soccergoals
}
\format{
  A data frame with 35 observations on the following 1 variable.
  \describe{
  \item{goals}{number of goals scored}
  }
}
\source{Collected by author from the www.espn.com website.}
\keyword{datasets}

\name{rmt}
\alias{rmt}
\title{Random number generation for multivariate t}
\description{
 Simulates from a multivariate t distribution
}
\usage{
rmt(n = 1, mean = rep(0, d), S, df = Inf)
}
\arguments{
  \item{n}{number of random numbers to be generated}
  \item{mean}{numeric vector giving the location parameter of the distribution}
  \item{S}{a positive definite matrix representing the scale matrix of the distribution}
  \item{df}{degrees of freedom}
}
\value{
matrix of n rows of random vectors
}

\author{Jim Albert}

\examples{
mu <- c(1,12,2)
Sigma <- matrix(c(1,2,0,2,5,0.5,0,0.5,3), 3, 3)
df <- 4
x <- rmt(10, mu, Sigma, df)
}

\keyword{models}

\name{prior.two.parameters}
\alias{prior.two.parameters}
\title{Construct discrete uniform prior for two parameters}
\description{
Constructs a discrete uniform prior distribution for two parameters
}
\usage{
prior.two.parameters(parameter1, parameter2)
}
\arguments{
  \item{parameter1}{vector of values of first parameter}
  \item{parameter2}{vector of values of second parameter}
}
\value{
  matrix of uniform probabilities where the rows and columns are
labelled with the parameter values
}

\author{Jim Albert}

\examples{
prior.two.parameters(c(1,2,3,4),c(2,4,7))
}

\keyword{models}
